(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('rxjs'), require('@angular/common/http'), require('jsrsasign'), require('rxjs/operators'), require('@angular/router')) :
    typeof define === 'function' && define.amd ? define('angular-library-starter', ['exports', '@angular/core', '@angular/common', 'rxjs', '@angular/common/http', 'jsrsasign', 'rxjs/operators', '@angular/router'], factory) :
    (factory((global.ng = global.ng || {}, global.ng.angularAuthOidcClient = {}),global.ng.core,global.ng.common,global.rxjs,global.ng.common.http,global.jsrsasign,global.rxjs.operators,global.ng.router));
}(this, (function (exports,core,common,rxjs,http,jsrsasign,operators,router) { 'use strict';

    /**
     * @license angular-auth-oidc-client
     * MIT license
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var AuthWellKnownEndpoints = /** @class */ (function () {
        function AuthWellKnownEndpoints() {
            this.issuer = '';
            this.jwks_uri = '';
            this.authorization_endpoint = '';
            this.token_endpoint = '';
            this.userinfo_endpoint = '';
            this.end_session_endpoint = '';
            this.check_session_iframe = '';
            this.revocation_endpoint = '';
            this.introspection_endpoint = '';
        }
        /**
         * @param {?} data
         * @return {?}
         */
        AuthWellKnownEndpoints.prototype.setWellKnownEndpoints = /**
         * @param {?} data
         * @return {?}
         */
        function (data) {
            this.issuer = data.issuer;
            this.jwks_uri = data.jwks_uri;
            this.authorization_endpoint = data.authorization_endpoint;
            this.token_endpoint = data.token_endpoint;
            this.userinfo_endpoint = data.userinfo_endpoint;
            if (data.end_session_endpoint) {
                this.end_session_endpoint = data.end_session_endpoint;
            }
            if (data.check_session_iframe) {
                this.check_session_iframe = data.check_session_iframe;
            }
            if (data.revocation_endpoint) {
                this.revocation_endpoint = data.revocation_endpoint;
            }
            if (data.introspection_endpoint) {
                this.introspection_endpoint = data.introspection_endpoint;
            }
        };
        return AuthWellKnownEndpoints;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var AuthorizationResult = /** @class */ (function () {
        function AuthorizationResult(authorizationState, validationResult) {
            this.authorizationState = authorizationState;
            this.validationResult = validationResult;
        }
        return AuthorizationResult;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    /** @enum {string} */
    var AuthorizationState = {
        authorized: 'authorized',
        forbidden: 'forbidden',
        unauthorized: 'unauthorized',
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var JwtKeys = /** @class */ (function () {
        function JwtKeys() {
            this.keys = [];
        }
        return JwtKeys;
    }());
    var JwtKey = /** @class */ (function () {
        function JwtKey() {
            this.kty = '';
            this.use = '';
            this.kid = '';
            this.x5t = '';
            this.e = '';
            this.n = '';
            this.x5c = [];
        }
        return JwtKey;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    /** @enum {string} */
    var ValidationResult = {
        NotSet: 'NotSet',
        StatesDoNotMatch: 'StatesDoNotMatch',
        SignatureFailed: 'SignatureFailed',
        IncorrectNonce: 'IncorrectNonce',
        RequiredPropertyMissing: 'RequiredPropertyMissing',
        MaxOffsetExpired: 'MaxOffsetExpired',
        IssDoesNotMatchIssuer: 'IssDoesNotMatchIssuer',
        NoAuthWellKnownEndPoints: 'NoAuthWellKnownEndPoints',
        IncorrectAud: 'IncorrectAud',
        TokenExpired: 'TokenExpired',
        IncorrectAtHash: 'IncorrectAtHash',
        Ok: 'Ok',
        LoginRequired: 'LoginRequired',
        SecureTokenServerError: 'SecureTokenServerError',
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var ValidateStateResult = /** @class */ (function () {
        function ValidateStateResult(access_token, id_token, authResponseIsValid, decoded_id_token, state) {
            if (access_token === void 0) { access_token = ''; }
            if (id_token === void 0) { id_token = ''; }
            if (authResponseIsValid === void 0) { authResponseIsValid = false; }
            if (decoded_id_token === void 0) { decoded_id_token = {}; }
            if (state === void 0) { state = ValidationResult.NotSet; }
            this.access_token = access_token;
            this.id_token = id_token;
            this.authResponseIsValid = authResponseIsValid;
            this.decoded_id_token = decoded_id_token;
            this.state = state;
        }
        return ValidateStateResult;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var OpenIDImplicitFlowConfiguration = /** @class */ (function () {
        function OpenIDImplicitFlowConfiguration() {
            this.stsServer = 'https://localhost:44318';
            this.redirect_url = 'https://localhost:44311';
            // The Client MUST validate that the aud (audience) Claim contains its client_id value registered at the Issuer identified
            // by the iss (issuer) Claim as an audience.
            // The ID Token MUST be rejected if the ID Token does not list the Client as a valid audience,
            // or if it contains additional audiences not trusted by the Client.
            this.client_id = 'angularclient';
            this.response_type = 'id_token token';
            this.scope = 'openid email profile';
            // Only for Google Auth with particular G Suite domain, see https://developers.google.com/identity/protocols/OpenIDConnect#hd-param
            this.hd_param = '';
            this.post_logout_redirect_uri = 'https://localhost:44311/unauthorized';
            this.start_checksession = false;
            this.silent_renew = false;
            this.silent_renew_url = 'https://localhost:44311';
            this.silent_renew_offset_in_seconds = 0;
            this.silent_redirect_url = 'https://localhost:44311';
            this.post_login_route = '/';
            // HTTP 403
            this.forbidden_route = '/forbidden';
            // HTTP 401
            this.unauthorized_route = '/unauthorized';
            this.auto_userinfo = true;
            this.auto_clean_state_after_authentication = true;
            this.trigger_authorization_result_event = false;
            this.log_console_warning_active = true;
            this.log_console_debug_active = false;
            this.iss_validation_off = false;
            this.history_cleanup_off = false;
            // id_token C8: The iat Claim can be used to reject tokens that were issued too far away from the current time,
            // limiting the amount of time that nonces need to be stored to prevent attacks.The acceptable range is Client specific.
            this.max_id_token_iat_offset_allowed_in_seconds = 3;
            this.storage = typeof Storage !== 'undefined' ? sessionStorage : null;
        }
        return OpenIDImplicitFlowConfiguration;
    }());
    var AuthConfiguration = /** @class */ (function () {
        function AuthConfiguration(platformId) {
            this.platformId = platformId;
            this._onConfigurationChange = new rxjs.Subject();
            this.defaultConfig = new OpenIDImplicitFlowConfiguration();
        }
        Object.defineProperty(AuthConfiguration.prototype, "stsServer", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.stsServer;
                }
                return this.defaultConfig.stsServer;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "redirect_url", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.redirect_url;
                }
                return this.defaultConfig.redirect_url;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "silent_redirect_url", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.silent_renew_url;
                }
                return this.defaultConfig.silent_renew_url;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "client_id", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.client_id;
                }
                return this.defaultConfig.client_id;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "response_type", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.response_type;
                }
                return this.defaultConfig.response_type;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "scope", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.scope;
                }
                return this.defaultConfig.scope;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "hd_param", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.hd_param;
                }
                return this.defaultConfig.hd_param;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "post_logout_redirect_uri", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.post_logout_redirect_uri;
                }
                return this.defaultConfig.post_logout_redirect_uri;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "start_checksession", {
            get: /**
             * @return {?}
             */
            function () {
                if (!common.isPlatformBrowser(this.platformId)) {
                    return false;
                }
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.start_checksession;
                }
                return this.defaultConfig.start_checksession;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "silent_renew", {
            get: /**
             * @return {?}
             */
            function () {
                if (!common.isPlatformBrowser(this.platformId)) {
                    return false;
                }
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.silent_renew;
                }
                return this.defaultConfig.silent_renew;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "silent_renew_offset_in_seconds", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.silent_renew_offset_in_seconds;
                }
                return this.defaultConfig.silent_renew_offset_in_seconds;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "post_login_route", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.post_login_route;
                }
                return this.defaultConfig.post_login_route;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "forbidden_route", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.forbidden_route;
                }
                return this.defaultConfig.forbidden_route;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "unauthorized_route", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.unauthorized_route;
                }
                return this.defaultConfig.unauthorized_route;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "auto_userinfo", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.auto_userinfo;
                }
                return this.defaultConfig.auto_userinfo;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "auto_clean_state_after_authentication", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.auto_clean_state_after_authentication;
                }
                return this.defaultConfig.auto_clean_state_after_authentication;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "trigger_authorization_result_event", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.trigger_authorization_result_event;
                }
                return this.defaultConfig.trigger_authorization_result_event;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "isLogLevelWarningEnabled", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.log_console_warning_active;
                }
                return this.defaultConfig.log_console_warning_active;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "isLogLevelDebugEnabled", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.log_console_debug_active;
                }
                return this.defaultConfig.log_console_debug_active;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "iss_validation_off", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.iss_validation_off;
                }
                return this.defaultConfig.iss_validation_off;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "history_cleanup_off", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.history_cleanup_off;
                }
                return this.defaultConfig.history_cleanup_off;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "max_id_token_iat_offset_allowed_in_seconds", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.max_id_token_iat_offset_allowed_in_seconds;
                }
                return this.defaultConfig.max_id_token_iat_offset_allowed_in_seconds;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthConfiguration.prototype, "storage", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.openIDImplicitFlowConfiguration) {
                    return this.openIDImplicitFlowConfiguration.storage;
                }
                return this.defaultConfig.storage;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} openIDImplicitFlowConfiguration
         * @return {?}
         */
        AuthConfiguration.prototype.init = /**
         * @param {?} openIDImplicitFlowConfiguration
         * @return {?}
         */
        function (openIDImplicitFlowConfiguration) {
            this.openIDImplicitFlowConfiguration = openIDImplicitFlowConfiguration;
            this._onConfigurationChange.next(openIDImplicitFlowConfiguration);
        };
        Object.defineProperty(AuthConfiguration.prototype, "onConfigurationChange", {
            get: /**
             * @return {?}
             */
            function () {
                return this._onConfigurationChange.asObservable();
            },
            enumerable: true,
            configurable: true
        });
        AuthConfiguration.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        AuthConfiguration.ctorParameters = function () { return [
            { type: Object, decorators: [{ type: core.Inject, args: [core.PLATFORM_ID,] },] },
        ]; };
        return AuthConfiguration;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var OidcDataService = /** @class */ (function () {
        function OidcDataService(httpClient) {
            this.httpClient = httpClient;
        }
        /**
         * @template T
         * @param {?} url
         * @return {?}
         */
        OidcDataService.prototype.getWellknownEndpoints = /**
         * @template T
         * @param {?} url
         * @return {?}
         */
        function (url) {
            var /** @type {?} */ headers = new http.HttpHeaders();
            headers = headers.set('Accept', 'application/json');
            return this.httpClient.get(url, {
                headers: headers,
            });
        };
        /**
         * @template T
         * @param {?} url
         * @param {?} token
         * @return {?}
         */
        OidcDataService.prototype.getIdentityUserData = /**
         * @template T
         * @param {?} url
         * @param {?} token
         * @return {?}
         */
        function (url, token) {
            var /** @type {?} */ headers = new http.HttpHeaders();
            headers = headers.set('Accept', 'application/json');
            headers = headers.set('Authorization', 'Bearer ' + decodeURIComponent(token));
            return this.httpClient.get(url, {
                headers: headers,
            });
        };
        /**
         * @template T
         * @param {?} url
         * @return {?}
         */
        OidcDataService.prototype.get = /**
         * @template T
         * @param {?} url
         * @return {?}
         */
        function (url) {
            var /** @type {?} */ headers = new http.HttpHeaders();
            headers = headers.set('Accept', 'application/json');
            return this.httpClient.get(url, {
                headers: headers,
            });
        };
        OidcDataService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        OidcDataService.ctorParameters = function () { return [
            { type: http.HttpClient, },
        ]; };
        return OidcDataService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var LoggerService = /** @class */ (function () {
        function LoggerService(authConfiguration) {
            this.authConfiguration = authConfiguration;
        }
        /**
         * @param {?} message
         * @return {?}
         */
        LoggerService.prototype.logError = /**
         * @param {?} message
         * @return {?}
         */
        function (message) {
            console.error(message);
        };
        /**
         * @param {?} message
         * @return {?}
         */
        LoggerService.prototype.logWarning = /**
         * @param {?} message
         * @return {?}
         */
        function (message) {
            if (this.authConfiguration.isLogLevelWarningEnabled) {
                console.warn(message);
            }
        };
        /**
         * @param {?} message
         * @return {?}
         */
        LoggerService.prototype.logDebug = /**
         * @param {?} message
         * @return {?}
         */
        function (message) {
            if (this.authConfiguration.isLogLevelDebugEnabled) {
                console.log(message);
            }
        };
        LoggerService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        LoggerService.ctorParameters = function () { return [
            { type: AuthConfiguration, },
        ]; };
        return LoggerService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var IFrameService = /** @class */ (function () {
        function IFrameService(loggerService) {
            this.loggerService = loggerService;
        }
        /**
         * @param {?} identifier
         * @return {?}
         */
        IFrameService.prototype.getExistingIFrame = /**
         * @param {?} identifier
         * @return {?}
         */
        function (identifier) {
            var /** @type {?} */ iFrameOnParent = this.getIFrameFromParentWindow(identifier);
            if (iFrameOnParent) {
                return iFrameOnParent;
            }
            return this.getIFrameFromWindow(identifier);
        };
        /**
         * @param {?} identifier
         * @return {?}
         */
        IFrameService.prototype.addIFrameToWindowBody = /**
         * @param {?} identifier
         * @return {?}
         */
        function (identifier) {
            var /** @type {?} */ sessionIframe = window.document.createElement('iframe');
            sessionIframe.id = identifier;
            this.loggerService.logDebug(sessionIframe);
            sessionIframe.style.display = 'none';
            window.document.body.appendChild(sessionIframe);
            return sessionIframe;
        };
        /**
         * @param {?} identifier
         * @return {?}
         */
        IFrameService.prototype.getIFrameFromParentWindow = /**
         * @param {?} identifier
         * @return {?}
         */
        function (identifier) {
            return window.parent.document.getElementById(identifier);
        };
        /**
         * @param {?} identifier
         * @return {?}
         */
        IFrameService.prototype.getIFrameFromWindow = /**
         * @param {?} identifier
         * @return {?}
         */
        function (identifier) {
            return window.document.getElementById(identifier);
        };
        IFrameService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        IFrameService.ctorParameters = function () { return [
            { type: LoggerService, },
        ]; };
        return IFrameService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var EqualityHelperService = /** @class */ (function () {
        function EqualityHelperService() {
        }
        /**
         * @param {?} value1
         * @param {?} value2
         * @return {?}
         */
        EqualityHelperService.prototype.areEqual = /**
         * @param {?} value1
         * @param {?} value2
         * @return {?}
         */
        function (value1, value2) {
            if (!value1 || !value2) {
                return false;
            }
            if (this.bothValuesAreArrays(value1, value2)) {
                return this.arraysEqual(/** @type {?} */ (value1), /** @type {?} */ (value2));
            }
            if (this.bothValuesAreStrings(value1, value2)) {
                return value1 === value2;
            }
            if (this.bothValuesAreObjects(value1, value2)) {
                return JSON.stringify(value1).toLowerCase() === JSON.stringify(value2).toLowerCase();
            }
            if (this.oneValueIsStringAndTheOtherIsArray(value1, value2)) {
                if (Array.isArray(value1) && this.valueIsString(value2)) {
                    return value1[0] === value2;
                }
                if (Array.isArray(value2) && this.valueIsString(value1)) {
                    return value2[0] === value1;
                }
            }
        };
        /**
         * @param {?} value1
         * @param {?} value2
         * @return {?}
         */
        EqualityHelperService.prototype.oneValueIsStringAndTheOtherIsArray = /**
         * @param {?} value1
         * @param {?} value2
         * @return {?}
         */
        function (value1, value2) {
            return (Array.isArray(value1) && this.valueIsString(value2)) || (Array.isArray(value2) && this.valueIsString(value1));
        };
        /**
         * @param {?} value1
         * @param {?} value2
         * @return {?}
         */
        EqualityHelperService.prototype.bothValuesAreObjects = /**
         * @param {?} value1
         * @param {?} value2
         * @return {?}
         */
        function (value1, value2) {
            return this.valueIsObject(value1) && this.valueIsObject(value2);
        };
        /**
         * @param {?} value1
         * @param {?} value2
         * @return {?}
         */
        EqualityHelperService.prototype.bothValuesAreStrings = /**
         * @param {?} value1
         * @param {?} value2
         * @return {?}
         */
        function (value1, value2) {
            return this.valueIsString(value1) && this.valueIsString(value2);
        };
        /**
         * @param {?} value1
         * @param {?} value2
         * @return {?}
         */
        EqualityHelperService.prototype.bothValuesAreArrays = /**
         * @param {?} value1
         * @param {?} value2
         * @return {?}
         */
        function (value1, value2) {
            return Array.isArray(value1) && Array.isArray(value2);
        };
        /**
         * @param {?} value
         * @return {?}
         */
        EqualityHelperService.prototype.valueIsString = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            return typeof value === 'string' || value instanceof String;
        };
        /**
         * @param {?} value
         * @return {?}
         */
        EqualityHelperService.prototype.valueIsObject = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            return typeof value === 'object';
        };
        /**
         * @param {?} arr1
         * @param {?} arr2
         * @return {?}
         */
        EqualityHelperService.prototype.arraysEqual = /**
         * @param {?} arr1
         * @param {?} arr2
         * @return {?}
         */
        function (arr1, arr2) {
            if (arr1.length !== arr2.length) {
                return false;
            }
            for (var /** @type {?} */ i = arr1.length; i--;) {
                if (arr1[i] !== arr2[i]) {
                    return false;
                }
            }
            return true;
        };
        EqualityHelperService.decorators = [
            { type: core.Injectable }
        ];
        return EqualityHelperService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var TokenHelperService = /** @class */ (function () {
        function TokenHelperService(loggerService) {
            this.loggerService = loggerService;
            this.PARTS_OF_TOKEN = 3;
        }
        /**
         * @param {?} dataIdToken
         * @return {?}
         */
        TokenHelperService.prototype.getTokenExpirationDate = /**
         * @param {?} dataIdToken
         * @return {?}
         */
        function (dataIdToken) {
            if (!dataIdToken.hasOwnProperty('exp')) {
                return new Date();
            }
            var /** @type {?} */ date = new Date(0); // The 0 here is the key, which sets the date to the epoch
            date.setUTCSeconds(dataIdToken.exp);
            return date;
        };
        /**
         * @param {?} token
         * @param {?} encoded
         * @return {?}
         */
        TokenHelperService.prototype.getHeaderFromToken = /**
         * @param {?} token
         * @param {?} encoded
         * @return {?}
         */
        function (token, encoded) {
            if (!this.tokenIsValid(token)) {
                return {};
            }
            return this.getPartOfToken(token, 0, encoded);
        };
        /**
         * @param {?} token
         * @param {?} encoded
         * @return {?}
         */
        TokenHelperService.prototype.getPayloadFromToken = /**
         * @param {?} token
         * @param {?} encoded
         * @return {?}
         */
        function (token, encoded) {
            if (!this.tokenIsValid(token)) {
                return {};
            }
            return this.getPartOfToken(token, 1, encoded);
        };
        /**
         * @param {?} token
         * @param {?} encoded
         * @return {?}
         */
        TokenHelperService.prototype.getSignatureFromToken = /**
         * @param {?} token
         * @param {?} encoded
         * @return {?}
         */
        function (token, encoded) {
            if (!this.tokenIsValid(token)) {
                return {};
            }
            return this.getPartOfToken(token, 2, encoded);
        };
        /**
         * @param {?} token
         * @param {?} index
         * @param {?} encoded
         * @return {?}
         */
        TokenHelperService.prototype.getPartOfToken = /**
         * @param {?} token
         * @param {?} index
         * @param {?} encoded
         * @return {?}
         */
        function (token, index, encoded) {
            var /** @type {?} */ partOfToken = this.extractPartOfToken(token, index);
            if (encoded) {
                return partOfToken;
            }
            var /** @type {?} */ result = this.urlBase64Decode(partOfToken);
            return JSON.parse(result);
        };
        /**
         * @param {?} str
         * @return {?}
         */
        TokenHelperService.prototype.urlBase64Decode = /**
         * @param {?} str
         * @return {?}
         */
        function (str) {
            var /** @type {?} */ output = str.replace(/-/g, '+').replace(/_/g, '/');
            switch (output.length % 4) {
                case 0:
                    break;
                case 2:
                    output += '==';
                    break;
                case 3:
                    output += '=';
                    break;
                default:
                    throw Error('Illegal base64url string!');
            }
            var /** @type {?} */ decoded = typeof window !== 'undefined' ? window.atob(output) : new Buffer(output, 'base64').toString('binary');
            try {
                // Going backwards: from bytestream, to percent-encoding, to original string.
                return decodeURIComponent(decoded.split('')
                    .map(function (c) { return '%' + ('00' + c.charCodeAt(0).toString(16)).slice(-2); })
                    .join(''));
            }
            catch (/** @type {?} */ err) {
                return decoded;
            }
        };
        /**
         * @param {?} token
         * @return {?}
         */
        TokenHelperService.prototype.tokenIsValid = /**
         * @param {?} token
         * @return {?}
         */
        function (token) {
            if (!token) {
                this.loggerService.logError("token '" + token + "' is not valid --> token falsy");
                return false;
            }
            if (!(/** @type {?} */ (token)).includes('.')) {
                this.loggerService.logError("token '" + token + "' is not valid --> no dots included");
                return false;
            }
            var /** @type {?} */ parts = token.split('.');
            if (parts.length !== this.PARTS_OF_TOKEN) {
                this.loggerService.logError("token '" + token + "' is not valid --> token has t have exact three dots");
                return false;
            }
            return true;
        };
        /**
         * @param {?} token
         * @param {?} index
         * @return {?}
         */
        TokenHelperService.prototype.extractPartOfToken = /**
         * @param {?} token
         * @param {?} index
         * @return {?}
         */
        function (token, index) {
            return token.split('.')[index];
        };
        TokenHelperService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        TokenHelperService.ctorParameters = function () { return [
            { type: LoggerService, },
        ]; };
        return TokenHelperService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    /**
     * Implement this class-interface to create a custom storage.
     * @abstract
     */
    var OidcSecurityStorage = /** @class */ (function () {
        function OidcSecurityStorage() {
        }
        OidcSecurityStorage.decorators = [
            { type: core.Injectable }
        ];
        return OidcSecurityStorage;
    }());
    var BrowserStorage = /** @class */ (function () {
        function BrowserStorage(authConfiguration) {
            this.authConfiguration = authConfiguration;
            this.hasStorage = typeof Storage !== 'undefined';
        }
        /**
         * @param {?} key
         * @return {?}
         */
        BrowserStorage.prototype.read = /**
         * @param {?} key
         * @return {?}
         */
        function (key) {
            if (this.hasStorage) {
                return JSON.parse(this.authConfiguration.storage.getItem(key + '_' + this.authConfiguration.client_id));
            }
            return;
        };
        /**
         * @param {?} key
         * @param {?} value
         * @return {?}
         */
        BrowserStorage.prototype.write = /**
         * @param {?} key
         * @param {?} value
         * @return {?}
         */
        function (key, value) {
            if (this.hasStorage) {
                value = value === undefined ? null : value;
                this.authConfiguration.storage.setItem(key + '_' + this.authConfiguration.client_id, JSON.stringify(value));
            }
        };
        BrowserStorage.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        BrowserStorage.ctorParameters = function () { return [
            { type: AuthConfiguration, },
        ]; };
        return BrowserStorage;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var OidcSecurityCommon = /** @class */ (function () {
        function OidcSecurityCommon(oidcSecurityStorage) {
            this.oidcSecurityStorage = oidcSecurityStorage;
            this.storage_auth_result = 'authorizationResult';
            this.storage_access_token = 'authorizationData';
            this.storage_id_token = 'authorizationDataIdToken';
            this.storage_is_authorized = '_isAuthorized';
            this.storage_user_data = 'userData';
            this.storage_auth_nonce = 'authNonce';
            this.storage_code_verifier = 'code_verifier';
            this.storage_auth_state_control = 'authStateControl';
            this.storage_session_state = 'session_state';
            this.storage_silent_renew_running = 'storage_silent_renew_running';
            this.storage_custom_request_params = 'storage_custom_request_params';
        }
        Object.defineProperty(OidcSecurityCommon.prototype, "authResult", {
            get: /**
             * @return {?}
             */
            function () {
                return this.retrieve(this.storage_auth_result);
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this.store(this.storage_auth_result, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OidcSecurityCommon.prototype, "accessToken", {
            get: /**
             * @return {?}
             */
            function () {
                return this.retrieve(this.storage_access_token) || '';
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this.store(this.storage_access_token, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OidcSecurityCommon.prototype, "idToken", {
            get: /**
             * @return {?}
             */
            function () {
                return this.retrieve(this.storage_id_token) || '';
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this.store(this.storage_id_token, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OidcSecurityCommon.prototype, "isAuthorized", {
            get: /**
             * @return {?}
             */
            function () {
                return this.retrieve(this.storage_is_authorized);
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this.store(this.storage_is_authorized, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OidcSecurityCommon.prototype, "userData", {
            get: /**
             * @return {?}
             */
            function () {
                return this.retrieve(this.storage_user_data);
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this.store(this.storage_user_data, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OidcSecurityCommon.prototype, "authNonce", {
            get: /**
             * @return {?}
             */
            function () {
                return this.retrieve(this.storage_auth_nonce) || '';
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this.store(this.storage_auth_nonce, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OidcSecurityCommon.prototype, "code_verifier", {
            get: /**
             * @return {?}
             */
            function () {
                return this.retrieve(this.storage_code_verifier) || '';
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this.store(this.storage_code_verifier, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OidcSecurityCommon.prototype, "authStateControl", {
            get: /**
             * @return {?}
             */
            function () {
                return this.retrieve(this.storage_auth_state_control) || '';
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this.store(this.storage_auth_state_control, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OidcSecurityCommon.prototype, "sessionState", {
            get: /**
             * @return {?}
             */
            function () {
                return this.retrieve(this.storage_session_state);
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this.store(this.storage_session_state, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OidcSecurityCommon.prototype, "silentRenewRunning", {
            get: /**
             * @return {?}
             */
            function () {
                return this.retrieve(this.storage_silent_renew_running) || '';
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this.store(this.storage_silent_renew_running, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OidcSecurityCommon.prototype, "customRequestParams", {
            get: /**
             * @return {?}
             */
            function () {
                return this.retrieve(this.storage_custom_request_params);
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this.store(this.storage_custom_request_params, value);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} key
         * @return {?}
         */
        OidcSecurityCommon.prototype.retrieve = /**
         * @param {?} key
         * @return {?}
         */
        function (key) {
            return this.oidcSecurityStorage.read(key);
        };
        /**
         * @param {?} key
         * @param {?} value
         * @return {?}
         */
        OidcSecurityCommon.prototype.store = /**
         * @param {?} key
         * @param {?} value
         * @return {?}
         */
        function (key, value) {
            this.oidcSecurityStorage.write(key, value);
        };
        /**
         * @param {?} isRenewProcess
         * @return {?}
         */
        OidcSecurityCommon.prototype.resetStorageData = /**
         * @param {?} isRenewProcess
         * @return {?}
         */
        function (isRenewProcess) {
            if (!isRenewProcess) {
                this.store(this.storage_auth_result, '');
                this.store(this.storage_session_state, '');
                this.store(this.storage_silent_renew_running, '');
                this.store(this.storage_is_authorized, false);
                this.store(this.storage_access_token, '');
                this.store(this.storage_id_token, '');
                this.store(this.storage_user_data, '');
                this.store(this.storage_code_verifier, '');
            }
        };
        /**
         * @return {?}
         */
        OidcSecurityCommon.prototype.getAccessToken = /**
         * @return {?}
         */
        function () {
            return this.retrieve(this.storage_access_token);
        };
        /**
         * @return {?}
         */
        OidcSecurityCommon.prototype.getIdToken = /**
         * @return {?}
         */
        function () {
            return this.retrieve(this.storage_id_token);
        };
        OidcSecurityCommon.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        OidcSecurityCommon.ctorParameters = function () { return [
            { type: OidcSecurityStorage, },
        ]; };
        return OidcSecurityCommon;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var OidcSecurityValidation = /** @class */ (function () {
        function OidcSecurityValidation(arrayHelperService, tokenHelperService, loggerService) {
            this.arrayHelperService = arrayHelperService;
            this.tokenHelperService = tokenHelperService;
            this.loggerService = loggerService;
        }
        // id_token C7: The current time MUST be before the time represented by the exp Claim (possibly allowing for some small leeway to account for clock skew).
        /**
         * @param {?} token
         * @param {?=} offsetSeconds
         * @return {?}
         */
        OidcSecurityValidation.prototype.isTokenExpired = /**
         * @param {?} token
         * @param {?=} offsetSeconds
         * @return {?}
         */
        function (token, offsetSeconds) {
            var /** @type {?} */ decoded;
            decoded = this.tokenHelperService.getPayloadFromToken(token, false);
            return !this.validate_id_token_exp_not_expired(decoded, offsetSeconds);
        };
        // id_token C7: The current time MUST be before the time represented by the exp Claim (possibly allowing for some small leeway to account for clock skew).
        /**
         * @param {?} decoded_id_token
         * @param {?=} offsetSeconds
         * @return {?}
         */
        OidcSecurityValidation.prototype.validate_id_token_exp_not_expired = /**
         * @param {?} decoded_id_token
         * @param {?=} offsetSeconds
         * @return {?}
         */
        function (decoded_id_token, offsetSeconds) {
            var /** @type {?} */ tokenExpirationDate = this.tokenHelperService.getTokenExpirationDate(decoded_id_token);
            offsetSeconds = offsetSeconds || 0;
            if (!tokenExpirationDate) {
                return false;
            }
            var /** @type {?} */ tokenExpirationValue = tokenExpirationDate.valueOf();
            var /** @type {?} */ nowWithOffset = new Date().valueOf() + offsetSeconds * 1000;
            var /** @type {?} */ tokenNotExpired = tokenExpirationValue > nowWithOffset;
            this.loggerService.logDebug("Token not expired?: " + tokenExpirationValue + " > " + nowWithOffset + "  (" + tokenNotExpired + ")");
            // Token not expired?
            return tokenNotExpired;
        };
        // iss
        // REQUIRED. Issuer Identifier for the Issuer of the response.The iss value is a case-sensitive URL using the https scheme that contains scheme, host,
        // and optionally, port number and path components and no query or fragment components.
        //
        // sub
        // REQUIRED. Subject Identifier.Locally unique and never reassigned identifier within the Issuer for the End- User,
        // which is intended to be consumed by the Client, e.g., 24400320 or AItOawmwtWwcT0k51BayewNvutrJUqsvl6qs7A4.
        // It MUST NOT exceed 255 ASCII characters in length.The sub value is a case-sensitive string.
        //
        // aud
        // REQUIRED. Audience(s) that this ID Token is intended for. It MUST contain the OAuth 2.0 client_id of the Relying Party as an audience value.
        // It MAY also contain identifiers for other audiences.In the general case, the aud value is an array of case-sensitive strings.
        // In the common special case when there is one audience, the aud value MAY be a single case-sensitive string.
        //
        // exp
        // REQUIRED. Expiration time on or after which the ID Token MUST NOT be accepted for processing.
        // The processing of this parameter requires that the current date/ time MUST be before the expiration date/ time listed in the value.
        // Implementers MAY provide for some small leeway, usually no more than a few minutes, to account for clock skew.
        // Its value is a JSON [RFC7159] number representing the number of seconds from 1970- 01 - 01T00: 00:00Z as measured in UTC until the date/ time.
        // See RFC 3339 [RFC3339] for details regarding date/ times in general and UTC in particular.
        //
        // iat
        // REQUIRED. Time at which the JWT was issued. Its value is a JSON number representing the number of seconds from 1970- 01 - 01T00: 00:00Z as measured
        // in UTC until the date/ time.
        /**
         * @param {?} dataIdToken
         * @return {?}
         */
        OidcSecurityValidation.prototype.validate_required_id_token = /**
         * @param {?} dataIdToken
         * @return {?}
         */
        function (dataIdToken) {
            var /** @type {?} */ validated = true;
            if (!dataIdToken.hasOwnProperty('iss')) {
                validated = false;
                this.loggerService.logWarning('iss is missing, this is required in the id_token');
            }
            if (!dataIdToken.hasOwnProperty('sub')) {
                validated = false;
                this.loggerService.logWarning('sub is missing, this is required in the id_token');
            }
            if (!dataIdToken.hasOwnProperty('aud')) {
                validated = false;
                this.loggerService.logWarning('aud is missing, this is required in the id_token');
            }
            if (!dataIdToken.hasOwnProperty('exp')) {
                validated = false;
                this.loggerService.logWarning('exp is missing, this is required in the id_token');
            }
            if (!dataIdToken.hasOwnProperty('iat')) {
                validated = false;
                this.loggerService.logWarning('iat is missing, this is required in the id_token');
            }
            return validated;
        };
        // id_token C8: The iat Claim can be used to reject tokens that were issued too far away from the current time,
        // limiting the amount of time that nonces need to be stored to prevent attacks.The acceptable range is Client specific.
        /**
         * @param {?} dataIdToken
         * @param {?} max_offset_allowed_in_seconds
         * @return {?}
         */
        OidcSecurityValidation.prototype.validate_id_token_iat_max_offset = /**
         * @param {?} dataIdToken
         * @param {?} max_offset_allowed_in_seconds
         * @return {?}
         */
        function (dataIdToken, max_offset_allowed_in_seconds) {
            if (!dataIdToken.hasOwnProperty('iat')) {
                return false;
            }
            var /** @type {?} */ dateTime_iat_id_token = new Date(0); // The 0 here is the key, which sets the date to the epoch
            dateTime_iat_id_token.setUTCSeconds(dataIdToken.iat);
            max_offset_allowed_in_seconds = max_offset_allowed_in_seconds || 0;
            if (dateTime_iat_id_token == null) {
                return false;
            }
            this.loggerService.logDebug('validate_id_token_iat_max_offset: ' +
                (new Date().valueOf() - dateTime_iat_id_token.valueOf()) +
                ' < ' +
                max_offset_allowed_in_seconds * 1000);
            return new Date().valueOf() - dateTime_iat_id_token.valueOf() < max_offset_allowed_in_seconds * 1000;
        };
        // id_token C9: The value of the nonce Claim MUST be checked to verify that it is the same value as the one
        // that was sent in the Authentication Request.The Client SHOULD check the nonce value for replay attacks.
        // The precise method for detecting replay attacks is Client specific.
        /**
         * @param {?} dataIdToken
         * @param {?} local_nonce
         * @return {?}
         */
        OidcSecurityValidation.prototype.validate_id_token_nonce = /**
         * @param {?} dataIdToken
         * @param {?} local_nonce
         * @return {?}
         */
        function (dataIdToken, local_nonce) {
            if (dataIdToken.nonce !== local_nonce) {
                this.loggerService.logDebug('Validate_id_token_nonce failed, dataIdToken.nonce: ' + dataIdToken.nonce + ' local_nonce:' + local_nonce);
                return false;
            }
            return true;
        };
        // id_token C1: The Issuer Identifier for the OpenID Provider (which is typically obtained during Discovery)
        // MUST exactly match the value of the iss (issuer) Claim.
        /**
         * @param {?} dataIdToken
         * @param {?} authWellKnownEndpoints_issuer
         * @return {?}
         */
        OidcSecurityValidation.prototype.validate_id_token_iss = /**
         * @param {?} dataIdToken
         * @param {?} authWellKnownEndpoints_issuer
         * @return {?}
         */
        function (dataIdToken, authWellKnownEndpoints_issuer) {
            if ((/** @type {?} */ (dataIdToken.iss)) !== (/** @type {?} */ (authWellKnownEndpoints_issuer))) {
                this.loggerService.logDebug('Validate_id_token_iss failed, dataIdToken.iss: ' +
                    dataIdToken.iss +
                    ' authWellKnownEndpoints issuer:' +
                    authWellKnownEndpoints_issuer);
                return false;
            }
            return true;
        };
        // id_token C2: The Client MUST validate that the aud (audience) Claim contains its client_id value registered at the Issuer identified
        // by the iss (issuer) Claim as an audience.
        // The ID Token MUST be rejected if the ID Token does not list the Client as a valid audience, or if it contains additional audiences
        // not trusted by the Client.
        /**
         * @param {?} dataIdToken
         * @param {?} aud
         * @return {?}
         */
        OidcSecurityValidation.prototype.validate_id_token_aud = /**
         * @param {?} dataIdToken
         * @param {?} aud
         * @return {?}
         */
        function (dataIdToken, aud) {
            if (dataIdToken.aud instanceof Array) {
                var /** @type {?} */ result = this.arrayHelperService.areEqual(dataIdToken.aud, aud);
                if (!result) {
                    this.loggerService.logDebug('Validate_id_token_aud  array failed, dataIdToken.aud: ' + dataIdToken.aud + ' client_id:' + aud);
                    return false;
                }
                return true;
            }
            else if (dataIdToken.aud !== aud) {
                this.loggerService.logDebug('Validate_id_token_aud failed, dataIdToken.aud: ' + dataIdToken.aud + ' client_id:' + aud);
                return false;
            }
            return true;
        };
        /**
         * @param {?} state
         * @param {?} local_state
         * @return {?}
         */
        OidcSecurityValidation.prototype.validateStateFromHashCallback = /**
         * @param {?} state
         * @param {?} local_state
         * @return {?}
         */
        function (state, local_state) {
            if ((/** @type {?} */ (state)) !== (/** @type {?} */ (local_state))) {
                this.loggerService.logDebug('ValidateStateFromHashCallback failed, state: ' + state + ' local_state:' + local_state);
                return false;
            }
            return true;
        };
        /**
         * @param {?} id_token_sub
         * @param {?} userdata_sub
         * @return {?}
         */
        OidcSecurityValidation.prototype.validate_userdata_sub_id_token = /**
         * @param {?} id_token_sub
         * @param {?} userdata_sub
         * @return {?}
         */
        function (id_token_sub, userdata_sub) {
            if ((/** @type {?} */ (id_token_sub)) !== (/** @type {?} */ (userdata_sub))) {
                this.loggerService.logDebug('validate_userdata_sub_id_token failed, id_token_sub: ' + id_token_sub + ' userdata_sub:' + userdata_sub);
                return false;
            }
            return true;
        };
        // id_token C5: The Client MUST validate the signature of the ID Token according to JWS [JWS] using the algorithm specified in the alg
        // Header Parameter of the JOSE Header.The Client MUST use the keys provided by the Issuer.
        // id_token C6: The alg value SHOULD be RS256. Validation of tokens using other signing algorithms is described in the
        // OpenID Connect Core 1.0 [OpenID.Core] specification.
        /**
         * @param {?} id_token
         * @param {?} jwtkeys
         * @return {?}
         */
        OidcSecurityValidation.prototype.validate_signature_id_token = /**
         * @param {?} id_token
         * @param {?} jwtkeys
         * @return {?}
         */
        function (id_token, jwtkeys) {
            if (!jwtkeys || !jwtkeys.keys) {
                return false;
            }
            var /** @type {?} */ header_data = this.tokenHelperService.getHeaderFromToken(id_token, false);
            if (Object.keys(header_data).length === 0 && header_data.constructor === Object) {
                this.loggerService.logWarning('id token has no header data');
                return false;
            }
            var /** @type {?} */ kid = header_data.kid;
            var /** @type {?} */ alg = header_data.alg;
            if ('RS256' !== (/** @type {?} */ (alg))) {
                this.loggerService.logWarning('Only RS256 supported');
                return false;
            }
            var /** @type {?} */ isValid = false;
            if (!header_data.hasOwnProperty('kid')) {
                // exactly 1 key in the jwtkeys and no kid in the Jose header
                // kty	"RSA" use "sig"
                var /** @type {?} */ amountOfMatchingKeys = 0;
                for (var _i = 0, _a = jwtkeys.keys; _i < _a.length; _i++) {
                    var key = _a[_i];
                    if ((/** @type {?} */ (key.kty)) === 'RSA' && (/** @type {?} */ (key.use)) === 'sig') {
                        amountOfMatchingKeys = amountOfMatchingKeys + 1;
                    }
                }
                if (amountOfMatchingKeys === 0) {
                    this.loggerService.logWarning('no keys found, incorrect Signature, validation failed for id_token');
                    return false;
                }
                else if (amountOfMatchingKeys > 1) {
                    this.loggerService.logWarning('no ID Token kid claim in JOSE header and multiple supplied in jwks_uri');
                    return false;
                }
                else {
                    for (var _b = 0, _c = jwtkeys.keys; _b < _c.length; _b++) {
                        var key = _c[_b];
                        if ((/** @type {?} */ (key.kty)) === 'RSA' && (/** @type {?} */ (key.use)) === 'sig') {
                            var /** @type {?} */ publickey = jsrsasign.KEYUTIL.getKey(key);
                            isValid = jsrsasign.KJUR.jws.JWS.verify(id_token, publickey, ['RS256']);
                            if (!isValid) {
                                this.loggerService.logWarning('incorrect Signature, validation failed for id_token');
                            }
                            return isValid;
                        }
                    }
                }
            }
            else {
                // kid in the Jose header of id_token
                for (var _d = 0, _e = jwtkeys.keys; _d < _e.length; _d++) {
                    var key = _e[_d];
                    if ((/** @type {?} */ (key.kid)) === (/** @type {?} */ (kid))) {
                        var /** @type {?} */ publickey = jsrsasign.KEYUTIL.getKey(key);
                        isValid = jsrsasign.KJUR.jws.JWS.verify(id_token, publickey, ['RS256']);
                        if (!isValid) {
                            this.loggerService.logWarning('incorrect Signature, validation failed for id_token');
                        }
                        return isValid;
                    }
                }
            }
            return isValid;
        };
        /**
         * @param {?} response_type
         * @return {?}
         */
        OidcSecurityValidation.prototype.config_validate_response_type = /**
         * @param {?} response_type
         * @return {?}
         */
        function (response_type) {
            if (response_type === 'id_token token' || response_type === 'id_token') {
                return true;
            }
            if (response_type === 'code') {
                return true;
            }
            this.loggerService.logWarning('module configure incorrect, invalid response_type:' + response_type);
            return false;
        };
        // Accepts ID Token without 'kid' claim in JOSE header if only one JWK supplied in 'jwks_url'
        //// private validate_no_kid_in_header_only_one_allowed_in_jwtkeys(header_data: any, jwtkeys: any): boolean {
        ////    this.oidcSecurityCommon.logDebug('amount of jwtkeys.keys: ' + jwtkeys.keys.length);
        ////    if (!header_data.hasOwnProperty('kid')) {
        ////        // no kid defined in Jose header
        ////        if (jwtkeys.keys.length != 1) {
        ////            this.oidcSecurityCommon.logDebug('jwtkeys.keys.length != 1 and no kid in header');
        ////            return false;
        ////        }
        ////    }
        ////    return true;
        //// }
        // Access Token Validation
        // access_token C1: Hash the octets of the ASCII representation of the access_token with the hash algorithm specified in JWA[JWA]
        // for the alg Header Parameter of the ID Token's JOSE Header. For instance, if the alg is RS256, the hash algorithm used is SHA-256.
        // access_token C2: Take the left- most half of the hash and base64url- encode it.
        // access_token C3: The value of at_hash in the ID Token MUST match the value produced in the previous step if at_hash
        // is present in the ID Token.
        /**
         * @param {?} access_token
         * @param {?} at_hash
         * @return {?}
         */
        OidcSecurityValidation.prototype.validate_id_token_at_hash = /**
         * @param {?} access_token
         * @param {?} at_hash
         * @return {?}
         */
        function (access_token, at_hash) {
            this.loggerService.logDebug('From the server:' + at_hash);
            var /** @type {?} */ testdata = this.generate_at_hash('' + access_token);
            this.loggerService.logDebug('client validation not decoded:' + testdata);
            if (testdata === (/** @type {?} */ (at_hash))) {
                return true; // isValid;
            }
            else {
                var /** @type {?} */ testValue = this.generate_at_hash('' + decodeURIComponent(access_token));
                this.loggerService.logDebug('-gen access--' + testValue);
                if (testValue === (/** @type {?} */ (at_hash))) {
                    return true; // isValid
                }
            }
            return false;
        };
        /**
         * @param {?} access_token
         * @return {?}
         */
        OidcSecurityValidation.prototype.generate_at_hash = /**
         * @param {?} access_token
         * @return {?}
         */
        function (access_token) {
            var /** @type {?} */ hash = jsrsasign.KJUR.crypto.Util.hashString(access_token, 'sha256');
            var /** @type {?} */ first128bits = hash.substr(0, hash.length / 2);
            var /** @type {?} */ testdata = jsrsasign.hextob64u(first128bits);
            return testdata;
        };
        /**
         * @param {?} code_challenge
         * @return {?}
         */
        OidcSecurityValidation.prototype.generate_code_verifier = /**
         * @param {?} code_challenge
         * @return {?}
         */
        function (code_challenge) {
            var /** @type {?} */ hash = jsrsasign.KJUR.crypto.Util.hashString(code_challenge, 'sha256');
            var /** @type {?} */ testdata = jsrsasign.hextob64u(hash);
            return testdata;
        };
        OidcSecurityValidation.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        OidcSecurityValidation.ctorParameters = function () { return [
            { type: EqualityHelperService, },
            { type: TokenHelperService, },
            { type: LoggerService, },
        ]; };
        return OidcSecurityValidation;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var StateValidationService = /** @class */ (function () {
        function StateValidationService(authConfiguration, oidcSecurityCommon, oidcSecurityValidation, tokenHelperService, loggerService) {
            this.authConfiguration = authConfiguration;
            this.oidcSecurityCommon = oidcSecurityCommon;
            this.oidcSecurityValidation = oidcSecurityValidation;
            this.tokenHelperService = tokenHelperService;
            this.loggerService = loggerService;
            this.authWellKnownEndpoints = new AuthWellKnownEndpoints();
        }
        /**
         * @param {?} authWellKnownEndpoints
         * @return {?}
         */
        StateValidationService.prototype.setupModule = /**
         * @param {?} authWellKnownEndpoints
         * @return {?}
         */
        function (authWellKnownEndpoints) {
            this.authWellKnownEndpoints = Object.assign({}, authWellKnownEndpoints);
        };
        /**
         * @param {?} result
         * @param {?} jwtKeys
         * @return {?}
         */
        StateValidationService.prototype.validateState = /**
         * @param {?} result
         * @param {?} jwtKeys
         * @return {?}
         */
        function (result, jwtKeys) {
            var /** @type {?} */ toReturn = new ValidateStateResult();
            if (!this.oidcSecurityValidation.validateStateFromHashCallback(result.state, this.oidcSecurityCommon.authStateControl)) {
                this.loggerService.logWarning('authorizedCallback incorrect state');
                toReturn.state = ValidationResult.StatesDoNotMatch;
                return toReturn;
            }
            if (this.authConfiguration.response_type === 'id_token token' || this.authConfiguration.response_type === 'code') {
                toReturn.access_token = result.access_token;
            }
            toReturn.id_token = result.id_token;
            toReturn.decoded_id_token = this.tokenHelperService.getPayloadFromToken(toReturn.id_token, false);
            if (!this.oidcSecurityValidation.validate_signature_id_token(toReturn.id_token, jwtKeys)) {
                this.loggerService.logDebug('authorizedCallback Signature validation failed id_token');
                toReturn.state = ValidationResult.SignatureFailed;
                return toReturn;
            }
            if (!this.oidcSecurityValidation.validate_id_token_nonce(toReturn.decoded_id_token, this.oidcSecurityCommon.authNonce)) {
                this.loggerService.logWarning('authorizedCallback incorrect nonce');
                toReturn.state = ValidationResult.IncorrectNonce;
                return toReturn;
            }
            if (!this.oidcSecurityValidation.validate_required_id_token(toReturn.decoded_id_token)) {
                this.loggerService.logDebug('authorizedCallback Validation, one of the REQUIRED properties missing from id_token');
                toReturn.state = ValidationResult.RequiredPropertyMissing;
                return toReturn;
            }
            if (!this.oidcSecurityValidation.validate_id_token_iat_max_offset(toReturn.decoded_id_token, this.authConfiguration.max_id_token_iat_offset_allowed_in_seconds)) {
                this.loggerService.logWarning('authorizedCallback Validation, iat rejected id_token was issued too far away from the current time');
                toReturn.state = ValidationResult.MaxOffsetExpired;
                return toReturn;
            }
            if (this.authWellKnownEndpoints) {
                if (this.authConfiguration.iss_validation_off) {
                    this.loggerService.logDebug('iss validation is turned off, this is not recommended!');
                }
                else if (!this.authConfiguration.iss_validation_off &&
                    !this.oidcSecurityValidation.validate_id_token_iss(toReturn.decoded_id_token, this.authWellKnownEndpoints.issuer)) {
                    this.loggerService.logWarning('authorizedCallback incorrect iss does not match authWellKnownEndpoints issuer');
                    toReturn.state = ValidationResult.IssDoesNotMatchIssuer;
                    return toReturn;
                }
            }
            else {
                this.loggerService.logWarning('authWellKnownEndpoints is undefined');
                toReturn.state = ValidationResult.NoAuthWellKnownEndPoints;
                return toReturn;
            }
            if (!this.oidcSecurityValidation.validate_id_token_aud(toReturn.decoded_id_token, this.authConfiguration.client_id)) {
                this.loggerService.logWarning('authorizedCallback incorrect aud');
                toReturn.state = ValidationResult.IncorrectAud;
                return toReturn;
            }
            if (!this.oidcSecurityValidation.validate_id_token_exp_not_expired(toReturn.decoded_id_token)) {
                this.loggerService.logWarning('authorizedCallback token expired');
                toReturn.state = ValidationResult.TokenExpired;
                return toReturn;
            }
            // flow id_token token
            if (this.authConfiguration.response_type !== 'id_token token' && this.authConfiguration.response_type !== 'code') {
                toReturn.authResponseIsValid = true;
                toReturn.state = ValidationResult.Ok;
                this.handleSuccessfulValidation();
                return toReturn;
            }
            if (!this.oidcSecurityValidation.validate_id_token_at_hash(toReturn.access_token, toReturn.decoded_id_token.at_hash) ||
                !toReturn.access_token) {
                this.loggerService.logWarning('authorizedCallback incorrect at_hash');
                toReturn.state = ValidationResult.IncorrectAtHash;
                return toReturn;
            }
            toReturn.authResponseIsValid = true;
            toReturn.state = ValidationResult.Ok;
            this.handleSuccessfulValidation();
            return toReturn;
        };
        /**
         * @return {?}
         */
        StateValidationService.prototype.handleSuccessfulValidation = /**
         * @return {?}
         */
        function () {
            this.oidcSecurityCommon.authNonce = '';
            if (this.authConfiguration.auto_clean_state_after_authentication) {
                this.oidcSecurityCommon.authStateControl = '';
            }
            this.loggerService.logDebug('AuthorizedCallback token(s) validated, continue');
        };
        StateValidationService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        StateValidationService.ctorParameters = function () { return [
            { type: AuthConfiguration, },
            { type: OidcSecurityCommon, },
            { type: OidcSecurityValidation, },
            { type: TokenHelperService, },
            { type: LoggerService, },
        ]; };
        return StateValidationService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var /** @type {?} */ IFRAME_FOR_CHECK_SESSION_IDENTIFIER = 'myiFrameForCheckSession';
    var OidcSecurityCheckSession = /** @class */ (function () {
        function OidcSecurityCheckSession(authConfiguration, oidcSecurityCommon, loggerService, iFrameService, zone) {
            this.authConfiguration = authConfiguration;
            this.oidcSecurityCommon = oidcSecurityCommon;
            this.loggerService = loggerService;
            this.iFrameService = iFrameService;
            this.zone = zone;
            this.lastIFrameRefresh = 0;
            this.outstandingMessages = 0;
            this.heartBeatInterval = 3000;
            this.iframeRefreshInterval = 60000;
            this._onCheckSessionChanged = new rxjs.Subject();
        }
        Object.defineProperty(OidcSecurityCheckSession.prototype, "onCheckSessionChanged", {
            get: /**
             * @return {?}
             */
            function () {
                return this._onCheckSessionChanged.asObservable();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} authWellKnownEndpoints
         * @return {?}
         */
        OidcSecurityCheckSession.prototype.setupModule = /**
         * @param {?} authWellKnownEndpoints
         * @return {?}
         */
        function (authWellKnownEndpoints) {
            this.authWellKnownEndpoints = Object.assign({}, authWellKnownEndpoints);
        };
        /**
         * @return {?}
         */
        OidcSecurityCheckSession.prototype.doesSessionExist = /**
         * @return {?}
         */
        function () {
            var /** @type {?} */ existingIFrame = this.iFrameService.getExistingIFrame(IFRAME_FOR_CHECK_SESSION_IDENTIFIER);
            if (!existingIFrame) {
                return false;
            }
            this.sessionIframe = existingIFrame;
            return true;
        };
        /**
         * @return {?}
         */
        OidcSecurityCheckSession.prototype.init = /**
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.lastIFrameRefresh + this.iframeRefreshInterval > Date.now()) {
                return rxjs.from([this]);
            }
            if (!this.doesSessionExist()) {
                this.sessionIframe = this.iFrameService.addIFrameToWindowBody(IFRAME_FOR_CHECK_SESSION_IDENTIFIER);
                this.iframeMessageEvent = this.messageHandler.bind(this);
                window.addEventListener('message', this.iframeMessageEvent, false);
            }
            if (this.authWellKnownEndpoints) {
                this.sessionIframe.contentWindow.location.replace(this.authWellKnownEndpoints.check_session_iframe);
            }
            else {
                this.loggerService.logWarning('init check session: authWellKnownEndpoints is undefined');
            }
            return rxjs.Observable.create(function (observer) {
                _this.sessionIframe.onload = function () {
                    _this.lastIFrameRefresh = Date.now();
                    observer.next(_this);
                    observer.complete();
                };
            });
        };
        /**
         * @param {?} clientId
         * @return {?}
         */
        OidcSecurityCheckSession.prototype.startCheckingSession = /**
         * @param {?} clientId
         * @return {?}
         */
        function (clientId) {
            if (this.scheduledHeartBeat) {
                return;
            }
            this.pollServerSession(clientId);
        };
        /**
         * @return {?}
         */
        OidcSecurityCheckSession.prototype.stopCheckingSession = /**
         * @return {?}
         */
        function () {
            if (!this.scheduledHeartBeat) {
                return;
            }
            this.clearScheduledHeartBeat();
        };
        /**
         * @param {?} clientId
         * @return {?}
         */
        OidcSecurityCheckSession.prototype.pollServerSession = /**
         * @param {?} clientId
         * @return {?}
         */
        function (clientId) {
            var _this = this;
            var /** @type {?} */ _pollServerSessionRecur = function () {
                _this.init()
                    .pipe(operators.take(1))
                    .subscribe(function () {
                    if (_this.sessionIframe && clientId) {
                        _this.loggerService.logDebug(_this.sessionIframe);
                        var /** @type {?} */ session_state = _this.oidcSecurityCommon.sessionState;
                        if (session_state) {
                            _this.outstandingMessages++;
                            _this.sessionIframe.contentWindow.postMessage(clientId + ' ' + session_state, _this.authConfiguration.stsServer);
                        }
                        else {
                            _this.loggerService.logDebug('OidcSecurityCheckSession pollServerSession session_state is blank');
                            _this._onCheckSessionChanged.next();
                        }
                    }
                    else {
                        _this.loggerService.logWarning('OidcSecurityCheckSession pollServerSession sessionIframe does not exist');
                        _this.loggerService.logDebug(clientId);
                        _this.loggerService.logDebug(_this.sessionIframe);
                        // this.init();
                    }
                    // after sending three messages with no response, fail.
                    if (_this.outstandingMessages > 3) {
                        _this.loggerService.logError("OidcSecurityCheckSession not receiving check session response messages. Outstanding messages: " + _this.outstandingMessages + ". Server unreachable?");
                        _this._onCheckSessionChanged.next();
                    }
                    _this.scheduledHeartBeat = setTimeout(_pollServerSessionRecur, _this.heartBeatInterval);
                });
            };
            this.outstandingMessages = 0;
            this.zone.runOutsideAngular(function () {
                _this.scheduledHeartBeat = setTimeout(_pollServerSessionRecur, _this.heartBeatInterval);
            });
        };
        /**
         * @return {?}
         */
        OidcSecurityCheckSession.prototype.clearScheduledHeartBeat = /**
         * @return {?}
         */
        function () {
            clearTimeout(this.scheduledHeartBeat);
            this.scheduledHeartBeat = null;
        };
        /**
         * @param {?} e
         * @return {?}
         */
        OidcSecurityCheckSession.prototype.messageHandler = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            this.outstandingMessages = 0;
            if (this.sessionIframe && e.origin === this.authConfiguration.stsServer && e.source === this.sessionIframe.contentWindow) {
                if (e.data === 'error') {
                    this.loggerService.logWarning('error from checksession messageHandler');
                }
                else if (e.data === 'changed') {
                    this._onCheckSessionChanged.next();
                }
                else {
                    this.loggerService.logDebug(e.data + ' from checksession messageHandler');
                }
            }
        };
        OidcSecurityCheckSession.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        OidcSecurityCheckSession.ctorParameters = function () { return [
            { type: AuthConfiguration, },
            { type: OidcSecurityCommon, },
            { type: LoggerService, },
            { type: IFrameService, },
            { type: core.NgZone, },
        ]; };
        return OidcSecurityCheckSession;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var OidcConfigService = /** @class */ (function () {
        function OidcConfigService(httpClient) {
            this.httpClient = httpClient;
            this._onConfigurationLoaded = new rxjs.Subject();
        }
        Object.defineProperty(OidcConfigService.prototype, "onConfigurationLoaded", {
            get: /**
             * @return {?}
             */
            function () {
                return this._onConfigurationLoaded.asObservable();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} configUrl
         * @return {?}
         */
        OidcConfigService.prototype.load = /**
         * @param {?} configUrl
         * @return {?}
         */
        function (configUrl) {
            var _this = this;
            this.httpClient
                .get(configUrl)
                .pipe(operators.map(function (response) {
                _this.clientConfiguration = response;
                _this.load_using_stsServer(_this.clientConfiguration.stsServer);
            }), operators.catchError(function (error) {
                console.error("OidcConfigService 'load' threw an error on calling " + configUrl, error);
                _this._onConfigurationLoaded.next(false);
                return rxjs.of(false);
            }))
                .subscribe();
        };
        /**
         * @param {?} stsServer
         * @return {?}
         */
        OidcConfigService.prototype.load_using_stsServer = /**
         * @param {?} stsServer
         * @return {?}
         */
        function (stsServer) {
            var _this = this;
            var /** @type {?} */ url = stsServer + "/.well-known/openid-configuration";
            this.httpClient
                .get(url)
                .pipe(operators.map(function (response) {
                _this.wellKnownEndpoints = response;
                _this._onConfigurationLoaded.next(true);
            }), operators.catchError(function (error) {
                console.error("OidcConfigService 'load_using_stsServer' threw an error on calling " + stsServer, error);
                _this._onConfigurationLoaded.next(false);
                return rxjs.of(false);
            }))
                .subscribe();
        };
        /**
         * @param {?} url
         * @return {?}
         */
        OidcConfigService.prototype.load_using_custom_stsServer = /**
         * @param {?} url
         * @return {?}
         */
        function (url) {
            var _this = this;
            this.httpClient
                .get(url)
                .pipe(operators.map(function (response) {
                _this.wellKnownEndpoints = response;
                _this._onConfigurationLoaded.next(true);
            }), operators.catchError(function (error) {
                console.error("OidcConfigService 'load_using_custom_stsServer' threw an error on calling " + url, error);
                _this._onConfigurationLoaded.next(false);
                return rxjs.of(false);
            }))
                .subscribe();
        };
        OidcConfigService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        OidcConfigService.ctorParameters = function () { return [
            { type: http.HttpClient, },
        ]; };
        return OidcConfigService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var /** @type {?} */ IFRAME_FOR_SILENT_RENEW_IDENTIFIER = 'myiFrameForSilentRenew';
    var OidcSecuritySilentRenew = /** @class */ (function () {
        function OidcSecuritySilentRenew(loggerService, iFrameService) {
            this.loggerService = loggerService;
            this.iFrameService = iFrameService;
            this.isRenewInitialized = false;
        }
        /**
         * @return {?}
         */
        OidcSecuritySilentRenew.prototype.initRenew = /**
         * @return {?}
         */
        function () {
            var /** @type {?} */ existingIFrame = this.iFrameService.getExistingIFrame(IFRAME_FOR_SILENT_RENEW_IDENTIFIER);
            if (!existingIFrame) {
                this.iFrameService.addIFrameToWindowBody(IFRAME_FOR_SILENT_RENEW_IDENTIFIER);
            }
            this.isRenewInitialized = true;
        };
        /**
         * @param {?} url
         * @return {?}
         */
        OidcSecuritySilentRenew.prototype.startRenew = /**
         * @param {?} url
         * @return {?}
         */
        function (url) {
            var _this = this;
            if (!this.isRenewInitialized) {
                this.initRenew();
            }
            this.sessionIframe = this.iFrameService.getExistingIFrame(IFRAME_FOR_SILENT_RENEW_IDENTIFIER);
            this.loggerService.logDebug('startRenew for URL:' + url);
            this.sessionIframe.contentWindow.location.replace(url);
            return rxjs.Observable.create(function (observer) {
                _this.sessionIframe.onload = function () {
                    observer.next(_this);
                    observer.complete();
                };
            });
        };
        OidcSecuritySilentRenew.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        OidcSecuritySilentRenew.ctorParameters = function () { return [
            { type: LoggerService, },
            { type: IFrameService, },
        ]; };
        return OidcSecuritySilentRenew;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var OidcSecurityUserService = /** @class */ (function () {
        function OidcSecurityUserService(oidcDataService, oidcSecurityCommon, loggerService) {
            this.oidcDataService = oidcDataService;
            this.oidcSecurityCommon = oidcSecurityCommon;
            this.loggerService = loggerService;
            this.userData = '';
        }
        /**
         * @param {?} authWellKnownEndpoints
         * @return {?}
         */
        OidcSecurityUserService.prototype.setupModule = /**
         * @param {?} authWellKnownEndpoints
         * @return {?}
         */
        function (authWellKnownEndpoints) {
            this.authWellKnownEndpoints = Object.assign({}, authWellKnownEndpoints);
        };
        /**
         * @return {?}
         */
        OidcSecurityUserService.prototype.initUserData = /**
         * @return {?}
         */
        function () {
            var _this = this;
            return this.getIdentityUserData().pipe(operators.map(function (data) { return (_this.userData = data); }));
        };
        /**
         * @return {?}
         */
        OidcSecurityUserService.prototype.getUserData = /**
         * @return {?}
         */
        function () {
            if (!this.userData) {
                throw Error('UserData is not set!');
            }
            return this.userData;
        };
        /**
         * @param {?} value
         * @return {?}
         */
        OidcSecurityUserService.prototype.setUserData = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.userData = value;
        };
        /**
         * @return {?}
         */
        OidcSecurityUserService.prototype.getIdentityUserData = /**
         * @return {?}
         */
        function () {
            var /** @type {?} */ token = this.oidcSecurityCommon.getAccessToken();
            if (!this.authWellKnownEndpoints) {
                this.loggerService.logWarning('init check session: authWellKnownEndpoints is undefined');
                throw Error('authWellKnownEndpoints is undefined');
            }
            var /** @type {?} */ canGetUserData = this.authWellKnownEndpoints && this.authWellKnownEndpoints.userinfo_endpoint;
            if (!canGetUserData) {
                this.loggerService.logError('init check session: authWellKnownEndpoints.userinfo_endpoint is undefined; set auto_userinfo = false in config');
                throw Error('authWellKnownEndpoints.userinfo_endpoint is undefined');
            }
            return this.oidcDataService.getIdentityUserData(this.authWellKnownEndpoints.userinfo_endpoint, token);
        };
        OidcSecurityUserService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        OidcSecurityUserService.ctorParameters = function () { return [
            { type: OidcDataService, },
            { type: OidcSecurityCommon, },
            { type: LoggerService, },
        ]; };
        return OidcSecurityUserService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var UriEncoder = /** @class */ (function () {
        function UriEncoder() {
        }
        /**
         * @param {?} key
         * @return {?}
         */
        UriEncoder.prototype.encodeKey = /**
         * @param {?} key
         * @return {?}
         */
        function (key) {
            return encodeURIComponent(key);
        };
        /**
         * @param {?} value
         * @return {?}
         */
        UriEncoder.prototype.encodeValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            return encodeURIComponent(value);
        };
        /**
         * @param {?} key
         * @return {?}
         */
        UriEncoder.prototype.decodeKey = /**
         * @param {?} key
         * @return {?}
         */
        function (key) {
            return decodeURIComponent(key);
        };
        /**
         * @param {?} value
         * @return {?}
         */
        UriEncoder.prototype.decodeValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            return decodeURIComponent(value);
        };
        return UriEncoder;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var OidcSecurityService = /** @class */ (function () {
        function OidcSecurityService(oidcDataService, stateValidationService, authConfiguration, router$$1, oidcSecurityCheckSession, oidcSecuritySilentRenew, oidcSecurityUserService, oidcSecurityCommon, oidcSecurityValidation, tokenHelperService, loggerService, zone, httpClient) {
            var _this = this;
            this.oidcDataService = oidcDataService;
            this.stateValidationService = stateValidationService;
            this.authConfiguration = authConfiguration;
            this.router = router$$1;
            this.oidcSecurityCheckSession = oidcSecurityCheckSession;
            this.oidcSecuritySilentRenew = oidcSecuritySilentRenew;
            this.oidcSecurityUserService = oidcSecurityUserService;
            this.oidcSecurityCommon = oidcSecurityCommon;
            this.oidcSecurityValidation = oidcSecurityValidation;
            this.tokenHelperService = tokenHelperService;
            this.loggerService = loggerService;
            this.zone = zone;
            this.httpClient = httpClient;
            this._onModuleSetup = new rxjs.Subject();
            this._onCheckSessionChanged = new rxjs.Subject();
            this._onAuthorizationResult = new rxjs.Subject();
            this.checkSessionChanged = false;
            this.moduleSetup = false;
            this._isModuleSetup = new rxjs.BehaviorSubject(false);
            this._isAuthorized = new rxjs.BehaviorSubject(false);
            this._userData = new rxjs.BehaviorSubject('');
            this.authWellKnownEndpointsLoaded = false;
            this.runTokenValidationRunning = false;
            this.onModuleSetup.pipe(operators.take(1)).subscribe(function () {
                _this.moduleSetup = true;
                _this._isModuleSetup.next(true);
            });
            this._isSetupAndAuthorized = this._isModuleSetup.pipe(operators.filter(function (isModuleSetup) { return isModuleSetup; }), operators.switchMap(function () {
                if (!_this.authConfiguration.silent_renew) {
                    return rxjs.from([true]).pipe(operators.tap(function () { return _this.loggerService.logDebug("IsAuthorizedRace: Silent Renew Not Active. Emitting."); }));
                }
                var /** @type {?} */ race$ = _this._isAuthorized.asObservable().pipe(operators.filter(function (isAuthorized) { return isAuthorized; }), operators.take(1), operators.tap(function () { return _this.loggerService.logDebug('IsAuthorizedRace: Existing token is still authorized.'); }), operators.race(_this._onAuthorizationResult.pipe(operators.take(1), operators.tap(function () { return _this.loggerService.logDebug('IsAuthorizedRace: Silent Renew Refresh Session Complete'); }), operators.map(function () { return true; })), rxjs.timer(5000).pipe(
                // backup, if nothing happens after 5 seconds stop waiting and emit
                operators.tap(function () { return _this.loggerService.logWarning('IsAuthorizedRace: Timeout reached. Emitting.'); }), operators.map(function () { return true; }))));
                _this.loggerService.logDebug('Silent Renew is active, check if token in storage is active');
                if (_this.oidcSecurityCommon.authNonce === '' || _this.oidcSecurityCommon.authNonce === undefined) {
                    // login not running, or a second silent renew, user must login first before this will work.
                    // login not running, or a second silent renew, user must login first before this will work.
                    _this.loggerService.logDebug('Silent Renew or login not running, try to refresh the session');
                    _this.refreshSession();
                }
                return race$;
            }), operators.tap(function () { return _this.loggerService.logDebug('IsAuthorizedRace: Completed'); }), operators.switchMapTo(this._isAuthorized.asObservable()), operators.tap(function (isAuthorized) { return _this.loggerService.logDebug("getIsAuthorized: " + isAuthorized); }), operators.shareReplay(1));
            this._isSetupAndAuthorized.pipe(operators.filter(function () { return _this.authConfiguration.start_checksession; })).subscribe(function (isSetupAndAuthorized) {
                if (isSetupAndAuthorized) {
                    _this.oidcSecurityCheckSession.startCheckingSession(_this.authConfiguration.client_id);
                }
                else {
                    _this.oidcSecurityCheckSession.stopCheckingSession();
                }
            });
        }
        Object.defineProperty(OidcSecurityService.prototype, "onModuleSetup", {
            get: /**
             * @return {?}
             */
            function () {
                return this._onModuleSetup.asObservable();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OidcSecurityService.prototype, "onAuthorizationResult", {
            get: /**
             * @return {?}
             */
            function () {
                return this._onAuthorizationResult.asObservable();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OidcSecurityService.prototype, "onCheckSessionChanged", {
            get: /**
             * @return {?}
             */
            function () {
                return this._onCheckSessionChanged.asObservable();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OidcSecurityService.prototype, "onConfigurationChange", {
            get: /**
             * @return {?}
             */
            function () {
                return this.authConfiguration.onConfigurationChange;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} openIDImplicitFlowConfiguration
         * @param {?} authWellKnownEndpoints
         * @return {?}
         */
        OidcSecurityService.prototype.setupModule = /**
         * @param {?} openIDImplicitFlowConfiguration
         * @param {?} authWellKnownEndpoints
         * @return {?}
         */
        function (openIDImplicitFlowConfiguration, authWellKnownEndpoints) {
            var _this = this;
            this.authWellKnownEndpoints = Object.assign({}, authWellKnownEndpoints);
            this.authConfiguration.init(openIDImplicitFlowConfiguration);
            this.stateValidationService.setupModule(authWellKnownEndpoints);
            this.oidcSecurityCheckSession.setupModule(authWellKnownEndpoints);
            this.oidcSecurityUserService.setupModule(authWellKnownEndpoints);
            this.oidcSecurityCheckSession.onCheckSessionChanged.subscribe(function () {
                _this.loggerService.logDebug('onCheckSessionChanged');
                _this.checkSessionChanged = true;
                _this._onCheckSessionChanged.next(_this.checkSessionChanged);
            });
            var /** @type {?} */ userData = this.oidcSecurityCommon.userData;
            if (userData) {
                this.setUserData(userData);
            }
            var /** @type {?} */ isAuthorized = this.oidcSecurityCommon.isAuthorized;
            if (isAuthorized) {
                this.loggerService.logDebug('IsAuthorized setup module');
                this.loggerService.logDebug(this.oidcSecurityCommon.idToken);
                if (this.oidcSecurityValidation.isTokenExpired(this.oidcSecurityCommon.idToken, this.authConfiguration.silent_renew_offset_in_seconds)) {
                    this.loggerService.logDebug('IsAuthorized setup module; id_token isTokenExpired');
                }
                else {
                    this.loggerService.logDebug('IsAuthorized setup module; id_token is valid');
                    this.setIsAuthorized(isAuthorized);
                }
                this.runTokenValidation();
            }
            this.loggerService.logDebug('STS server: ' + this.authConfiguration.stsServer);
            this._onModuleSetup.next();
            if (this.authConfiguration.silent_renew) {
                this.oidcSecuritySilentRenew.initRenew();
                // Support authorization via DOM events.
                // Deregister if OidcSecurityService.setupModule is called again by any instance.
                //      We only ever want the latest setup service to be reacting to this event.
                this.boundSilentRenewEvent = this.silentRenewEventHandler.bind(this);
                var /** @type {?} */ instanceId_1 = Math.random();
                var /** @type {?} */ boundSilentRenewInitEvent_1 = (function (e) {
                    if (e.detail !== instanceId_1) {
                        window.removeEventListener('oidc-silent-renew-message', _this.boundSilentRenewEvent);
                        window.removeEventListener('oidc-silent-renew-init', boundSilentRenewInitEvent_1);
                    }
                }).bind(this);
                window.addEventListener('oidc-silent-renew-init', boundSilentRenewInitEvent_1, false);
                window.addEventListener('oidc-silent-renew-message', this.boundSilentRenewEvent, false);
                window.dispatchEvent(new CustomEvent('oidc-silent-renew-init', {
                    detail: instanceId_1,
                }));
            }
        };
        /**
         * @return {?}
         */
        OidcSecurityService.prototype.getUserData = /**
         * @return {?}
         */
        function () {
            return this._userData.asObservable();
        };
        /**
         * @return {?}
         */
        OidcSecurityService.prototype.getIsModuleSetup = /**
         * @return {?}
         */
        function () {
            return this._isModuleSetup.asObservable();
        };
        /**
         * @return {?}
         */
        OidcSecurityService.prototype.getIsAuthorized = /**
         * @return {?}
         */
        function () {
            return this._isSetupAndAuthorized;
        };
        /**
         * @return {?}
         */
        OidcSecurityService.prototype.getToken = /**
         * @return {?}
         */
        function () {
            if (!this._isAuthorized.getValue()) {
                return '';
            }
            var /** @type {?} */ token = this.oidcSecurityCommon.getAccessToken();
            return decodeURIComponent(token);
        };
        /**
         * @return {?}
         */
        OidcSecurityService.prototype.getIdToken = /**
         * @return {?}
         */
        function () {
            if (!this._isAuthorized.getValue()) {
                return '';
            }
            var /** @type {?} */ token = this.oidcSecurityCommon.getIdToken();
            return decodeURIComponent(token);
        };
        /**
         * @param {?=} encode
         * @return {?}
         */
        OidcSecurityService.prototype.getPayloadFromIdToken = /**
         * @param {?=} encode
         * @return {?}
         */
        function (encode) {
            if (encode === void 0) { encode = false; }
            var /** @type {?} */ token = this.getIdToken();
            return this.tokenHelperService.getPayloadFromToken(token, encode);
        };
        /**
         * @param {?} state
         * @return {?}
         */
        OidcSecurityService.prototype.setState = /**
         * @param {?} state
         * @return {?}
         */
        function (state) {
            this.oidcSecurityCommon.authStateControl = state;
        };
        /**
         * @return {?}
         */
        OidcSecurityService.prototype.getState = /**
         * @return {?}
         */
        function () {
            return this.oidcSecurityCommon.authStateControl;
        };
        /**
         * @param {?} params
         * @return {?}
         */
        OidcSecurityService.prototype.setCustomRequestParameters = /**
         * @param {?} params
         * @return {?}
         */
        function (params) {
            this.oidcSecurityCommon.customRequestParams = params;
        };
        // Code Flow with PCKE or Implicit Flow
        /**
         * @param {?=} urlHandler
         * @return {?}
         */
        OidcSecurityService.prototype.authorize = /**
         * @param {?=} urlHandler
         * @return {?}
         */
        function (urlHandler) {
            if (this.authWellKnownEndpoints) {
                this.authWellKnownEndpointsLoaded = true;
            }
            if (!this.authWellKnownEndpointsLoaded) {
                this.loggerService.logError('Well known endpoints must be loaded before user can login!');
                return;
            }
            if (!this.oidcSecurityValidation.config_validate_response_type(this.authConfiguration.response_type)) {
                // invalid response_type
                return;
            }
            this.resetAuthorizationData(false);
            this.loggerService.logDebug('BEGIN Authorize Code Flow, no auth data');
            var /** @type {?} */ state = this.oidcSecurityCommon.authStateControl;
            if (!state) {
                state = Date.now() + '' + Math.random();
                this.oidcSecurityCommon.authStateControl = state;
            }
            var /** @type {?} */ nonce = 'N' + Math.random() + '' + Date.now();
            this.oidcSecurityCommon.authNonce = nonce;
            this.loggerService.logDebug('AuthorizedController created. local state: ' + this.oidcSecurityCommon.authStateControl);
            var /** @type {?} */ url = '';
            // Code Flow
            if (this.authConfiguration.response_type === 'code') {
                // code_challenge with "S256"
                var /** @type {?} */ code_verifier = 'C' + Math.random() + '' + Date.now() + '' + Date.now() + Math.random();
                var /** @type {?} */ code_challenge = this.oidcSecurityValidation.generate_code_verifier(code_verifier);
                this.oidcSecurityCommon.code_verifier = code_verifier;
                if (this.authWellKnownEndpoints) {
                    url = this.createAuthorizeUrl(true, code_challenge, this.authConfiguration.redirect_url, nonce, state, this.authWellKnownEndpoints.authorization_endpoint);
                }
                else {
                    this.loggerService.logError('authWellKnownEndpoints is undefined');
                }
            }
            else {
                // Implicit Flow
                if (this.authWellKnownEndpoints) {
                    url = this.createAuthorizeUrl(false, '', this.authConfiguration.redirect_url, nonce, state, this.authWellKnownEndpoints.authorization_endpoint);
                }
                else {
                    this.loggerService.logError('authWellKnownEndpoints is undefined');
                }
            }
            if (urlHandler) {
                urlHandler(url);
            }
            else {
                this.redirectTo(url);
            }
        };
        // Code Flow
        /**
         * @param {?} urlToCheck
         * @return {?}
         */
        OidcSecurityService.prototype.authorizedCallbackWithCode = /**
         * @param {?} urlToCheck
         * @return {?}
         */
        function (urlToCheck) {
            var /** @type {?} */ urlParts = urlToCheck.split('?');
            var /** @type {?} */ params = new http.HttpParams({
                fromString: urlParts[1]
            });
            var /** @type {?} */ code = params.get('code');
            var /** @type {?} */ state = params.get('state');
            var /** @type {?} */ session_state = params.get('session_state');
            if (code && state && session_state) {
                this.requestTokensWithCode(code, state, session_state);
            }
        };
        // Code Flow
        /**
         * @param {?} code
         * @param {?} state
         * @param {?} session_state
         * @return {?}
         */
        OidcSecurityService.prototype.requestTokensWithCode = /**
         * @param {?} code
         * @param {?} state
         * @param {?} session_state
         * @return {?}
         */
        function (code, state, session_state) {
            var _this = this;
            this._isModuleSetup
                .pipe(operators.filter(function (isModuleSetup) { return isModuleSetup; }), operators.take(1))
                .subscribe(function () {
                _this.requestTokensWithCodeProcedure(code, state, session_state);
            });
        };
        // Code Flow with PCKE
        /**
         * @param {?} code
         * @param {?} state
         * @param {?} session_state
         * @return {?}
         */
        OidcSecurityService.prototype.requestTokensWithCodeProcedure = /**
         * @param {?} code
         * @param {?} state
         * @param {?} session_state
         * @return {?}
         */
        function (code, state, session_state) {
            var _this = this;
            var /** @type {?} */ tokenRequestUrl = '';
            if (this.authWellKnownEndpoints && this.authWellKnownEndpoints.token_endpoint) {
                tokenRequestUrl = "" + this.authWellKnownEndpoints.token_endpoint;
            }
            if (!this.oidcSecurityValidation.validateStateFromHashCallback(state, this.oidcSecurityCommon.authStateControl)) {
                this.loggerService.logWarning('authorizedCallback incorrect state');
                // ValidationResult.StatesDoNotMatch;
                return;
            }
            var /** @type {?} */ headers = new http.HttpHeaders();
            headers = headers.set('Content-Type', 'application/x-www-form-urlencoded');
            var /** @type {?} */ data = "grant_type=authorization_code&client_id=" + this.authConfiguration.client_id
                + ("&code_verifier=" + this.oidcSecurityCommon.code_verifier + "&code=" + code + "&redirect_uri=" + this.authConfiguration.redirect_url);
            if (this.oidcSecurityCommon.silentRenewRunning === 'running') {
                data = "grant_type=authorization_code&client_id=" + this.authConfiguration.client_id
                    + ("&code_verifier=" + this.oidcSecurityCommon.code_verifier + "&code=" + code + "&redirect_uri=" + this.authConfiguration.silent_redirect_url);
            }
            this.httpClient
                .post(tokenRequestUrl, data, { headers: headers })
                .pipe(operators.map(function (response) {
                var /** @type {?} */ obj = new Object;
                obj = response;
                obj.state = state;
                obj.session_state = session_state;
                _this.authorizedCodeFlowCallbackProcedure(obj);
            }), operators.catchError(function (error) {
                _this.loggerService.logError(error);
                _this.loggerService.logError("OidcService code request " + _this.authConfiguration.stsServer);
                return rxjs.of(false);
            }))
                .subscribe();
        };
        /**
         * @param {?} result
         * @return {?}
         */
        OidcSecurityService.prototype.authorizedCodeFlowCallbackProcedure = /**
         * @param {?} result
         * @return {?}
         */
        function (result) {
            var /** @type {?} */ silentRenew = this.oidcSecurityCommon.silentRenewRunning;
            var /** @type {?} */ isRenewProcess = silentRenew === 'running';
            this.loggerService.logDebug('BEGIN authorized Code Flow Callback, no auth data');
            this.resetAuthorizationData(isRenewProcess);
            this.authorizedCallbackProcedure(result, isRenewProcess);
        };
        /**
         * @param {?=} hash
         * @return {?}
         */
        OidcSecurityService.prototype.authorizedImplicitFlowCallbackProcedure = /**
         * @param {?=} hash
         * @return {?}
         */
        function (hash) {
            var /** @type {?} */ silentRenew = this.oidcSecurityCommon.silentRenewRunning;
            var /** @type {?} */ isRenewProcess = silentRenew === 'running';
            this.loggerService.logDebug('BEGIN authorizedCallback, no auth data');
            this.resetAuthorizationData(isRenewProcess);
            hash = hash || window.location.hash.substr(1);
            var /** @type {?} */ result = hash.split('&').reduce(function (resultData, item) {
                var /** @type {?} */ parts = item.split('=');
                resultData[/** @type {?} */ (parts.shift())] = parts.join('=');
                return resultData;
            }, {});
            this.authorizedCallbackProcedure(result, isRenewProcess);
        };
        // Implicit Flow
        /**
         * @param {?=} hash
         * @return {?}
         */
        OidcSecurityService.prototype.authorizedImplicitFlowCallback = /**
         * @param {?=} hash
         * @return {?}
         */
        function (hash) {
            var _this = this;
            this._isModuleSetup
                .pipe(operators.filter(function (isModuleSetup) { return isModuleSetup; }), operators.take(1))
                .subscribe(function () {
                _this.authorizedImplicitFlowCallbackProcedure(hash);
            });
        };
        /**
         * @param {?} url
         * @return {?}
         */
        OidcSecurityService.prototype.redirectTo = /**
         * @param {?} url
         * @return {?}
         */
        function (url) {
            window.location.href = url;
        };
        /**
         * @param {?} result
         * @param {?} isRenewProcess
         * @return {?}
         */
        OidcSecurityService.prototype.authorizedCallbackProcedure = /**
         * @param {?} result
         * @param {?} isRenewProcess
         * @return {?}
         */
        function (result, isRenewProcess) {
            var _this = this;
            this.oidcSecurityCommon.authResult = result;
            if (!this.authConfiguration.history_cleanup_off && !isRenewProcess) {
                // reset the history to remove the tokens
                window.history.replaceState({}, window.document.title, window.location.origin + window.location.pathname);
            }
            else {
                this.loggerService.logDebug('history clean up inactive');
            }
            if (result.error) {
                this.loggerService.logWarning(result);
                if ((/** @type {?} */ (result.error)) === 'login_required') {
                    this._onAuthorizationResult.next(new AuthorizationResult(AuthorizationState.unauthorized, ValidationResult.LoginRequired));
                }
                else {
                    this._onAuthorizationResult.next(new AuthorizationResult(AuthorizationState.unauthorized, ValidationResult.SecureTokenServerError));
                }
                if (!this.authConfiguration.trigger_authorization_result_event && !isRenewProcess) {
                    this.router.navigate([this.authConfiguration.unauthorized_route]);
                }
            }
            else {
                this.loggerService.logDebug(result);
                this.loggerService.logDebug('authorizedCallback created, begin token validation');
                this.getSigningKeys().subscribe(function (jwtKeys) {
                    var /** @type {?} */ validationResult = _this.getValidatedStateResult(result, jwtKeys);
                    if (validationResult.authResponseIsValid) {
                        _this.setAuthorizationData(validationResult.access_token, validationResult.id_token);
                        _this.oidcSecurityCommon.silentRenewRunning = '';
                        if (_this.authConfiguration.auto_userinfo) {
                            _this.getUserinfo(isRenewProcess, result, validationResult.id_token, validationResult.decoded_id_token).subscribe(function (response) {
                                if (response) {
                                    _this._onAuthorizationResult.next(new AuthorizationResult(AuthorizationState.authorized, validationResult.state));
                                    if (!_this.authConfiguration.trigger_authorization_result_event && !isRenewProcess) {
                                        _this.router.navigate([_this.authConfiguration.post_login_route]);
                                    }
                                }
                                else {
                                    _this._onAuthorizationResult.next(new AuthorizationResult(AuthorizationState.unauthorized, validationResult.state));
                                    if (!_this.authConfiguration.trigger_authorization_result_event && !isRenewProcess) {
                                        _this.router.navigate([_this.authConfiguration.unauthorized_route]);
                                    }
                                }
                            }, function (err) {
                                /* Something went wrong while getting signing key */
                                /* Something went wrong while getting signing key */
                                _this.loggerService.logWarning('Failed to retreive user info with error: ' + JSON.stringify(err));
                            });
                        }
                        else {
                            if (!isRenewProcess) {
                                // userData is set to the id_token decoded, auto get user data set to false
                                // userData is set to the id_token decoded, auto get user data set to false
                                _this.oidcSecurityUserService.setUserData(validationResult.decoded_id_token);
                                _this.setUserData(_this.oidcSecurityUserService.getUserData());
                            }
                            _this.runTokenValidation();
                            _this._onAuthorizationResult.next(new AuthorizationResult(AuthorizationState.authorized, validationResult.state));
                            if (!_this.authConfiguration.trigger_authorization_result_event && !isRenewProcess) {
                                _this.router.navigate([_this.authConfiguration.post_login_route]);
                            }
                        }
                    }
                    else {
                        // something went wrong
                        // something went wrong
                        _this.loggerService.logWarning('authorizedCallback, token(s) validation failed, resetting');
                        _this.loggerService.logWarning(window.location.hash);
                        _this.resetAuthorizationData(false);
                        _this.oidcSecurityCommon.silentRenewRunning = '';
                        _this._onAuthorizationResult.next(new AuthorizationResult(AuthorizationState.unauthorized, validationResult.state));
                        if (!_this.authConfiguration.trigger_authorization_result_event && !isRenewProcess) {
                            _this.router.navigate([_this.authConfiguration.unauthorized_route]);
                        }
                    }
                }, function (err) {
                    /* Something went wrong while getting signing key */
                    /* Something went wrong while getting signing key */
                    _this.loggerService.logWarning('Failed to retreive siging key with error: ' + JSON.stringify(err));
                    _this.oidcSecurityCommon.silentRenewRunning = '';
                });
            }
        };
        /**
         * @param {?=} isRenewProcess
         * @param {?=} result
         * @param {?=} id_token
         * @param {?=} decoded_id_token
         * @return {?}
         */
        OidcSecurityService.prototype.getUserinfo = /**
         * @param {?=} isRenewProcess
         * @param {?=} result
         * @param {?=} id_token
         * @param {?=} decoded_id_token
         * @return {?}
         */
        function (isRenewProcess, result, id_token, decoded_id_token) {
            var _this = this;
            if (isRenewProcess === void 0) { isRenewProcess = false; }
            result = result ? result : this.oidcSecurityCommon.authResult;
            id_token = id_token ? id_token : this.oidcSecurityCommon.idToken;
            decoded_id_token = decoded_id_token ? decoded_id_token : this.tokenHelperService.getPayloadFromToken(id_token, false);
            return new rxjs.Observable(function (observer) {
                // flow id_token token
                if (_this.authConfiguration.response_type === 'id_token token' || _this.authConfiguration.response_type === 'code') {
                    if (isRenewProcess && _this._userData.value) {
                        _this.oidcSecurityCommon.sessionState = result.session_state;
                        observer.next(true);
                        observer.complete();
                    }
                    else {
                        _this.oidcSecurityUserService.initUserData().subscribe(function () {
                            _this.loggerService.logDebug('authorizedCallback (id_token token || code) flow');
                            var /** @type {?} */ userData = _this.oidcSecurityUserService.getUserData();
                            if (_this.oidcSecurityValidation.validate_userdata_sub_id_token(decoded_id_token.sub, userData.sub)) {
                                _this.setUserData(userData);
                                _this.loggerService.logDebug(_this.oidcSecurityCommon.accessToken);
                                _this.loggerService.logDebug(_this.oidcSecurityUserService.getUserData());
                                _this.oidcSecurityCommon.sessionState = result.session_state;
                                _this.runTokenValidation();
                                observer.next(true);
                            }
                            else {
                                // something went wrong, userdata sub does not match that from id_token
                                // something went wrong, userdata sub does not match that from id_token
                                _this.loggerService.logWarning('authorizedCallback, User data sub does not match sub in id_token');
                                _this.loggerService.logDebug('authorizedCallback, token(s) validation failed, resetting');
                                _this.resetAuthorizationData(false);
                                observer.next(false);
                            }
                            observer.complete();
                        });
                    }
                }
                else {
                    // flow id_token
                    // flow id_token
                    _this.loggerService.logDebug('authorizedCallback id_token flow');
                    _this.loggerService.logDebug(_this.oidcSecurityCommon.accessToken);
                    // userData is set to the id_token decoded. No access_token.
                    // userData is set to the id_token decoded. No access_token.
                    _this.oidcSecurityUserService.setUserData(decoded_id_token);
                    _this.setUserData(_this.oidcSecurityUserService.getUserData());
                    _this.oidcSecurityCommon.sessionState = result.session_state;
                    _this.runTokenValidation();
                    observer.next(true);
                    observer.complete();
                }
            });
        };
        /**
         * @param {?=} urlHandler
         * @return {?}
         */
        OidcSecurityService.prototype.logoff = /**
         * @param {?=} urlHandler
         * @return {?}
         */
        function (urlHandler) {
            // /connect/endsession?id_token_hint=...&post_logout_redirect_uri=https://myapp.com
            this.loggerService.logDebug('BEGIN Authorize, no auth data');
            if (this.authWellKnownEndpoints) {
                if (this.authWellKnownEndpoints.end_session_endpoint) {
                    var /** @type {?} */ end_session_endpoint = this.authWellKnownEndpoints.end_session_endpoint;
                    var /** @type {?} */ id_token_hint = this.oidcSecurityCommon.idToken;
                    var /** @type {?} */ url = this.createEndSessionUrl(end_session_endpoint, id_token_hint);
                    this.resetAuthorizationData(false);
                    if (this.authConfiguration.start_checksession && this.checkSessionChanged) {
                        this.loggerService.logDebug('only local login cleaned up, server session has changed');
                    }
                    else if (urlHandler) {
                        urlHandler(url);
                    }
                    else {
                        this.redirectTo(url);
                    }
                }
                else {
                    this.resetAuthorizationData(false);
                    this.loggerService.logDebug('only local login cleaned up, no end_session_endpoint');
                }
            }
            else {
                this.loggerService.logWarning('authWellKnownEndpoints is undefined');
            }
        };
        /**
         * @return {?}
         */
        OidcSecurityService.prototype.refreshSession = /**
         * @return {?}
         */
        function () {
            if (!this.authConfiguration.silent_renew) {
                return rxjs.from([false]);
            }
            this.loggerService.logDebug('BEGIN refresh session Authorize');
            var /** @type {?} */ state = this.oidcSecurityCommon.authStateControl;
            if (state === '' || state === null) {
                state = Date.now() + '' + Math.random();
                this.oidcSecurityCommon.authStateControl = state;
            }
            var /** @type {?} */ nonce = 'N' + Math.random() + '' + Date.now();
            this.oidcSecurityCommon.authNonce = nonce;
            this.loggerService.logDebug('RefreshSession created. adding myautostate: ' + this.oidcSecurityCommon.authStateControl);
            var /** @type {?} */ url = '';
            // Code Flow
            if (this.authConfiguration.response_type === 'code') {
                // code_challenge with "S256"
                var /** @type {?} */ code_verifier = 'C' + Math.random() + '' + Date.now() + '' + Date.now() + Math.random();
                var /** @type {?} */ code_challenge = this.oidcSecurityValidation.generate_code_verifier(code_verifier);
                this.oidcSecurityCommon.code_verifier = code_verifier;
                if (this.authWellKnownEndpoints) {
                    url = this.createAuthorizeUrl(true, code_challenge, this.authConfiguration.silent_redirect_url, nonce, state, this.authWellKnownEndpoints.authorization_endpoint, 'none');
                }
                else {
                    this.loggerService.logWarning('authWellKnownEndpoints is undefined');
                }
            }
            else {
                if (this.authWellKnownEndpoints) {
                    url = this.createAuthorizeUrl(false, '', this.authConfiguration.silent_redirect_url, nonce, state, this.authWellKnownEndpoints.authorization_endpoint, 'none');
                }
                else {
                    this.loggerService.logWarning('authWellKnownEndpoints is undefined');
                }
            }
            this.oidcSecurityCommon.silentRenewRunning = 'running';
            return this.oidcSecuritySilentRenew.startRenew(url);
        };
        /**
         * @param {?} error
         * @return {?}
         */
        OidcSecurityService.prototype.handleError = /**
         * @param {?} error
         * @return {?}
         */
        function (error) {
            this.loggerService.logError(error);
            if (error.status === 403 || error.status === '403') {
                if (this.authConfiguration.trigger_authorization_result_event) {
                    this._onAuthorizationResult.next(new AuthorizationResult(AuthorizationState.unauthorized, ValidationResult.NotSet));
                }
                else {
                    this.router.navigate([this.authConfiguration.forbidden_route]);
                }
            }
            else if (error.status === 401 || error.status === '401') {
                var /** @type {?} */ silentRenew = this.oidcSecurityCommon.silentRenewRunning;
                this.resetAuthorizationData(!!silentRenew);
                if (this.authConfiguration.trigger_authorization_result_event) {
                    this._onAuthorizationResult.next(new AuthorizationResult(AuthorizationState.unauthorized, ValidationResult.NotSet));
                }
                else {
                    this.router.navigate([this.authConfiguration.unauthorized_route]);
                }
            }
        };
        /**
         * @return {?}
         */
        OidcSecurityService.prototype.startCheckingSilentRenew = /**
         * @return {?}
         */
        function () {
            this.runTokenValidation();
        };
        /**
         * @return {?}
         */
        OidcSecurityService.prototype.stopCheckingSilentRenew = /**
         * @return {?}
         */
        function () {
            if (this._scheduledHeartBeat) {
                clearTimeout(this._scheduledHeartBeat);
                this._scheduledHeartBeat = null;
                this.runTokenValidationRunning = false;
            }
        };
        /**
         * @param {?} isRenewProcess
         * @return {?}
         */
        OidcSecurityService.prototype.resetAuthorizationData = /**
         * @param {?} isRenewProcess
         * @return {?}
         */
        function (isRenewProcess) {
            if (!isRenewProcess) {
                if (this.authConfiguration.auto_userinfo) {
                    // Clear user data. Fixes #97.
                    this.setUserData('');
                }
                this.oidcSecurityCommon.resetStorageData(isRenewProcess);
                this.checkSessionChanged = false;
                this.setIsAuthorized(false);
            }
        };
        /**
         * @return {?}
         */
        OidcSecurityService.prototype.getEndSessionUrl = /**
         * @return {?}
         */
        function () {
            if (this.authWellKnownEndpoints) {
                if (this.authWellKnownEndpoints.end_session_endpoint) {
                    var /** @type {?} */ end_session_endpoint = this.authWellKnownEndpoints.end_session_endpoint;
                    var /** @type {?} */ id_token_hint = this.oidcSecurityCommon.idToken;
                    return this.createEndSessionUrl(end_session_endpoint, id_token_hint);
                }
            }
        };
        /**
         * @param {?} result
         * @param {?} jwtKeys
         * @return {?}
         */
        OidcSecurityService.prototype.getValidatedStateResult = /**
         * @param {?} result
         * @param {?} jwtKeys
         * @return {?}
         */
        function (result, jwtKeys) {
            if (result.error) {
                return new ValidateStateResult('', '', false, {});
            }
            return this.stateValidationService.validateState(result, jwtKeys);
        };
        /**
         * @param {?} userData
         * @return {?}
         */
        OidcSecurityService.prototype.setUserData = /**
         * @param {?} userData
         * @return {?}
         */
        function (userData) {
            this.oidcSecurityCommon.userData = userData;
            this._userData.next(userData);
        };
        /**
         * @param {?} isAuthorized
         * @return {?}
         */
        OidcSecurityService.prototype.setIsAuthorized = /**
         * @param {?} isAuthorized
         * @return {?}
         */
        function (isAuthorized) {
            this._isAuthorized.next(isAuthorized);
        };
        /**
         * @param {?} access_token
         * @param {?} id_token
         * @return {?}
         */
        OidcSecurityService.prototype.setAuthorizationData = /**
         * @param {?} access_token
         * @param {?} id_token
         * @return {?}
         */
        function (access_token, id_token) {
            if (this.oidcSecurityCommon.accessToken !== '') {
                this.oidcSecurityCommon.accessToken = '';
            }
            this.loggerService.logDebug(access_token);
            this.loggerService.logDebug(id_token);
            this.loggerService.logDebug('storing to storage, getting the roles');
            this.oidcSecurityCommon.accessToken = access_token;
            this.oidcSecurityCommon.idToken = id_token;
            this.setIsAuthorized(true);
            this.oidcSecurityCommon.isAuthorized = true;
        };
        /**
         * @param {?} isCodeFlow
         * @param {?} code_challenge
         * @param {?} redirect_url
         * @param {?} nonce
         * @param {?} state
         * @param {?} authorization_endpoint
         * @param {?=} prompt
         * @return {?}
         */
        OidcSecurityService.prototype.createAuthorizeUrl = /**
         * @param {?} isCodeFlow
         * @param {?} code_challenge
         * @param {?} redirect_url
         * @param {?} nonce
         * @param {?} state
         * @param {?} authorization_endpoint
         * @param {?=} prompt
         * @return {?}
         */
        function (isCodeFlow, code_challenge, redirect_url, nonce, state, authorization_endpoint, prompt) {
            var /** @type {?} */ urlParts = authorization_endpoint.split('?');
            var /** @type {?} */ authorizationUrl = urlParts[0];
            var /** @type {?} */ params = new http.HttpParams({
                fromString: urlParts[1],
                encoder: new UriEncoder(),
            });
            params = params.set('client_id', this.authConfiguration.client_id);
            params = params.append('redirect_uri', redirect_url);
            params = params.append('response_type', this.authConfiguration.response_type);
            params = params.append('scope', this.authConfiguration.scope);
            params = params.append('nonce', nonce);
            params = params.append('state', state);
            if (isCodeFlow) {
                params = params.append('code_challenge', code_challenge);
                params = params.append('code_challenge_method', 'S256');
            }
            if (prompt) {
                params = params.append('prompt', prompt);
            }
            if (this.authConfiguration.hd_param) {
                params = params.append('hd', this.authConfiguration.hd_param);
            }
            var /** @type {?} */ customParams = Object.assign({}, this.oidcSecurityCommon.customRequestParams);
            Object.keys(customParams).forEach(function (key) {
                params = params.append(key, customParams[key].toString());
            });
            return authorizationUrl + "?" + params;
        };
        /**
         * @param {?} end_session_endpoint
         * @param {?} id_token_hint
         * @return {?}
         */
        OidcSecurityService.prototype.createEndSessionUrl = /**
         * @param {?} end_session_endpoint
         * @param {?} id_token_hint
         * @return {?}
         */
        function (end_session_endpoint, id_token_hint) {
            var /** @type {?} */ urlParts = end_session_endpoint.split('?');
            var /** @type {?} */ authorizationEndsessionUrl = urlParts[0];
            var /** @type {?} */ params = new http.HttpParams({
                fromString: urlParts[1],
                encoder: new UriEncoder(),
            });
            params = params.set('id_token_hint', id_token_hint);
            params = params.append('post_logout_redirect_uri', this.authConfiguration.post_logout_redirect_uri);
            return authorizationEndsessionUrl + "?" + params;
        };
        /**
         * @return {?}
         */
        OidcSecurityService.prototype.getSigningKeys = /**
         * @return {?}
         */
        function () {
            if (this.authWellKnownEndpoints) {
                this.loggerService.logDebug('jwks_uri: ' + this.authWellKnownEndpoints.jwks_uri);
                return this.oidcDataService.get(this.authWellKnownEndpoints.jwks_uri).pipe(operators.catchError(this.handleErrorGetSigningKeys));
            }
            else {
                this.loggerService.logWarning('getSigningKeys: authWellKnownEndpoints is undefined');
            }
            return this.oidcDataService.get('undefined').pipe(operators.catchError(this.handleErrorGetSigningKeys));
        };
        /**
         * @param {?} error
         * @return {?}
         */
        OidcSecurityService.prototype.handleErrorGetSigningKeys = /**
         * @param {?} error
         * @return {?}
         */
        function (error) {
            var /** @type {?} */ errMsg;
            if (error instanceof Response) {
                var /** @type {?} */ body = error.json() || {};
                var /** @type {?} */ err = JSON.stringify(body);
                errMsg = error.status + " - " + (error.statusText || '') + " " + err;
            }
            else {
                errMsg = error.message ? error.message : error.toString();
            }
            console.error(errMsg);
            return rxjs.throwError(errMsg);
        };
        /**
         * @return {?}
         */
        OidcSecurityService.prototype.runTokenValidation = /**
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.runTokenValidationRunning || !this.authConfiguration.silent_renew) {
                return;
            }
            this.runTokenValidationRunning = true;
            this.loggerService.logDebug('runTokenValidation silent-renew running');
            /**
             * First time: delay 10 seconds to call silentRenewHeartBeatCheck
             * Afterwards: Run this check in a 5 second interval only AFTER the previous operation ends.
             */
            var /** @type {?} */ silentRenewHeartBeatCheck = function () {
                _this.loggerService.logDebug('silentRenewHeartBeatCheck\r\n' +
                    ("\tsilentRenewRunning: " + (_this.oidcSecurityCommon.silentRenewRunning === 'running') + "\r\n") +
                    ("\tidToken: " + (_this.getIdToken() != null) + "\r\n") +
                    ("\t_userData.value: " + (_this._userData.value != null)));
                if (_this._userData.value && _this.oidcSecurityCommon.silentRenewRunning !== 'running' && _this.getIdToken()) {
                    if (_this.oidcSecurityValidation.isTokenExpired(_this.oidcSecurityCommon.idToken, _this.authConfiguration.silent_renew_offset_in_seconds)) {
                        _this.loggerService.logDebug('IsAuthorized: id_token isTokenExpired, start silent renew if active');
                        if (_this.authConfiguration.silent_renew) {
                            _this.refreshSession().subscribe(function () {
                                _this._scheduledHeartBeat = setTimeout(silentRenewHeartBeatCheck, 3000);
                            }, function (err) {
                                _this.loggerService.logError('Error: ' + err);
                                _this._scheduledHeartBeat = setTimeout(silentRenewHeartBeatCheck, 3000);
                            });
                            /* In this situation, we schedule a heatbeat check only when silentRenew is finished.
                                                    We don't want to schedule another check so we have to return here */
                            return;
                        }
                        else {
                            _this.resetAuthorizationData(false);
                        }
                    }
                }
                /* Delay 3 seconds and do the next check */
                /* Delay 3 seconds and do the next check */
                _this._scheduledHeartBeat = setTimeout(silentRenewHeartBeatCheck, 3000);
            };
            this.zone.runOutsideAngular(function () {
                /* Initial heartbeat check */
                /* Initial heartbeat check */
                _this._scheduledHeartBeat = setTimeout(silentRenewHeartBeatCheck, 10000);
            });
        };
        /**
         * @param {?} e
         * @return {?}
         */
        OidcSecurityService.prototype.silentRenewEventHandler = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            this.loggerService.logDebug('silentRenewEventHandler');
            if (this.authConfiguration.response_type === 'code') {
                var /** @type {?} */ urlParts = e.detail.toString().split('?');
                var /** @type {?} */ params = new http.HttpParams({
                    fromString: urlParts[1]
                });
                var /** @type {?} */ code = params.get('code');
                var /** @type {?} */ state = params.get('state');
                var /** @type {?} */ session_state = params.get('session_state');
                var /** @type {?} */ error = params.get('error');
                if (code && state && session_state) {
                    this.requestTokensWithCodeProcedure(code, state, session_state);
                }
                if (error) {
                    this.loggerService.logDebug(e.detail.toString());
                }
            }
            else {
                // ImplicitFlow
                this.authorizedImplicitFlowCallback(e.detail);
            }
        };
        OidcSecurityService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        OidcSecurityService.ctorParameters = function () { return [
            { type: OidcDataService, },
            { type: StateValidationService, },
            { type: AuthConfiguration, },
            { type: router.Router, },
            { type: OidcSecurityCheckSession, },
            { type: OidcSecuritySilentRenew, },
            { type: OidcSecurityUserService, },
            { type: OidcSecurityCommon, },
            { type: OidcSecurityValidation, },
            { type: TokenHelperService, },
            { type: LoggerService, },
            { type: core.NgZone, },
            { type: http.HttpClient, },
        ]; };
        return OidcSecurityService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var AuthModule = /** @class */ (function () {
        function AuthModule() {
        }
        /**
         * @param {?=} token
         * @return {?}
         */
        AuthModule.forRoot = /**
         * @param {?=} token
         * @return {?}
         */
        function (token) {
            if (token === void 0) { token = {}; }
            return {
                ngModule: AuthModule,
                providers: [
                    OidcConfigService,
                    OidcSecurityService,
                    OidcSecurityValidation,
                    OidcSecurityCheckSession,
                    OidcSecuritySilentRenew,
                    OidcSecurityUserService,
                    OidcSecurityCommon,
                    AuthConfiguration,
                    TokenHelperService,
                    LoggerService,
                    IFrameService,
                    EqualityHelperService,
                    AuthWellKnownEndpoints,
                    OidcDataService,
                    StateValidationService,
                    {
                        provide: OidcSecurityStorage,
                        useClass: token.storage || BrowserStorage,
                    },
                ],
            };
        };
        AuthModule.decorators = [
            { type: core.NgModule }
        ];
        return AuthModule;
    }());

    exports.AuthWellKnownEndpoints = AuthWellKnownEndpoints;
    exports.AuthorizationResult = AuthorizationResult;
    exports.AuthorizationState = AuthorizationState;
    exports.JwtKeys = JwtKeys;
    exports.JwtKey = JwtKey;
    exports.ValidateStateResult = ValidateStateResult;
    exports.ValidationResult = ValidationResult;
    exports.OpenIDImplicitFlowConfiguration = OpenIDImplicitFlowConfiguration;
    exports.AuthConfiguration = AuthConfiguration;
    exports.AuthModule = AuthModule;
    exports.OidcConfigService = OidcConfigService;
    exports.OidcSecurityService = OidcSecurityService;
    exports.OidcSecurityStorage = OidcSecurityStorage;
    exports.BrowserStorage = BrowserStorage;
    exports.OidcSecurityValidation = OidcSecurityValidation;
    exports.ɵa = OidcDataService;
    exports.ɵh = IFrameService;
    exports.ɵd = EqualityHelperService;
    exports.ɵb = StateValidationService;
    exports.ɵe = TokenHelperService;
    exports.ɵf = LoggerService;
    exports.ɵg = OidcSecurityCheckSession;
    exports.ɵc = OidcSecurityCommon;
    exports.ɵi = OidcSecuritySilentRenew;
    exports.ɵj = OidcSecurityUserService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angular-auth-oidc-client.umd.js.map
