/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
var OidcDataService = /** @class */ (function () {
    function OidcDataService(httpClient) {
        this.httpClient = httpClient;
    }
    /**
     * @template T
     * @param {?} url
     * @return {?}
     */
    OidcDataService.prototype.getWellknownEndpoints = /**
     * @template T
     * @param {?} url
     * @return {?}
     */
    function (url) {
        var /** @type {?} */ headers = new HttpHeaders();
        headers = headers.set('Accept', 'application/json');
        return this.httpClient.get(url, {
            headers: headers,
        });
    };
    /**
     * @template T
     * @param {?} url
     * @param {?} token
     * @return {?}
     */
    OidcDataService.prototype.getIdentityUserData = /**
     * @template T
     * @param {?} url
     * @param {?} token
     * @return {?}
     */
    function (url, token) {
        var /** @type {?} */ headers = new HttpHeaders();
        headers = headers.set('Accept', 'application/json');
        headers = headers.set('Authorization', 'Bearer ' + decodeURIComponent(token));
        return this.httpClient.get(url, {
            headers: headers,
        });
    };
    /**
     * @template T
     * @param {?} url
     * @return {?}
     */
    OidcDataService.prototype.get = /**
     * @template T
     * @param {?} url
     * @return {?}
     */
    function (url) {
        var /** @type {?} */ headers = new HttpHeaders();
        headers = headers.set('Accept', 'application/json');
        return this.httpClient.get(url, {
            headers: headers,
        });
    };
    OidcDataService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    OidcDataService.ctorParameters = function () { return [
        { type: HttpClient, },
    ]; };
    return OidcDataService;
}());
export { OidcDataService };
function OidcDataService_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    OidcDataService.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    OidcDataService.ctorParameters;
    /** @type {?} */
    OidcDataService.prototype.httpClient;
}
//# sourceMappingURL=oidc-data.service.js.map