/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { of, Subject } from 'rxjs';
import { catchError, map } from 'rxjs/operators';
var OidcConfigService = /** @class */ (function () {
    function OidcConfigService(httpClient) {
        this.httpClient = httpClient;
        this._onConfigurationLoaded = new Subject();
    }
    Object.defineProperty(OidcConfigService.prototype, "onConfigurationLoaded", {
        get: /**
         * @return {?}
         */
        function () {
            return this._onConfigurationLoaded.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} configUrl
     * @return {?}
     */
    OidcConfigService.prototype.load = /**
     * @param {?} configUrl
     * @return {?}
     */
    function (configUrl) {
        var _this = this;
        this.httpClient
            .get(configUrl)
            .pipe(map(function (response) {
            _this.clientConfiguration = response;
            _this.load_using_stsServer(_this.clientConfiguration.stsServer);
        }), catchError(function (error) {
            console.error("OidcConfigService 'load' threw an error on calling " + configUrl, error);
            _this._onConfigurationLoaded.next(false);
            return of(false);
        }))
            .subscribe();
    };
    /**
     * @param {?} stsServer
     * @return {?}
     */
    OidcConfigService.prototype.load_using_stsServer = /**
     * @param {?} stsServer
     * @return {?}
     */
    function (stsServer) {
        var _this = this;
        var /** @type {?} */ url = stsServer + "/.well-known/openid-configuration";
        this.httpClient
            .get(url)
            .pipe(map(function (response) {
            _this.wellKnownEndpoints = response;
            _this._onConfigurationLoaded.next(true);
        }), catchError(function (error) {
            console.error("OidcConfigService 'load_using_stsServer' threw an error on calling " + stsServer, error);
            _this._onConfigurationLoaded.next(false);
            return of(false);
        }))
            .subscribe();
    };
    /**
     * @param {?} url
     * @return {?}
     */
    OidcConfigService.prototype.load_using_custom_stsServer = /**
     * @param {?} url
     * @return {?}
     */
    function (url) {
        var _this = this;
        this.httpClient
            .get(url)
            .pipe(map(function (response) {
            _this.wellKnownEndpoints = response;
            _this._onConfigurationLoaded.next(true);
        }), catchError(function (error) {
            console.error("OidcConfigService 'load_using_custom_stsServer' threw an error on calling " + url, error);
            _this._onConfigurationLoaded.next(false);
            return of(false);
        }))
            .subscribe();
    };
    OidcConfigService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    OidcConfigService.ctorParameters = function () { return [
        { type: HttpClient, },
    ]; };
    return OidcConfigService;
}());
export { OidcConfigService };
function OidcConfigService_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    OidcConfigService.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    OidcConfigService.ctorParameters;
    /** @type {?} */
    OidcConfigService.prototype._onConfigurationLoaded;
    /** @type {?} */
    OidcConfigService.prototype.clientConfiguration;
    /** @type {?} */
    OidcConfigService.prototype.wellKnownEndpoints;
    /** @type {?} */
    OidcConfigService.prototype.httpClient;
}
//# sourceMappingURL=oidc.security.config.service.js.map